 
#!/bin/bash
#!  
#! "CTB-SL"    (B)asic version plus ScanList plus HelpPages
#!
#! 
#!   Standard GNU General Public License Software:
#! 
lcSetCtrl="0"
if [ lcSetCtrl ] ; then
    set -e
fi
#
#! System Developer Initial DOB is "gcSysDevDob'
#! ----------------------------------------------------------------
export gcSysDevDobPrev="220623-0045"
export gcSysDevDob="220711-1723"
export gcSysDevDob="220714-0752"
export gcSysDevDob="221224-2100"
export gcSysDevDob="221225-2222"
export gcSysDevDob="221228-0743"
export gcSysDevDob="221230-2200"
export gcSysDevDob="230101-1829"
export gcSysDevDob="230102-1907"
#! ----------------------------------------------------------------
export gcSysDevId="CTB-SL"    # ScanList	
export gcSysDevVer="4.1"
#! ----------------------------------------------------------------
function Sys_SetVerDts() {
export gcCTBparam1="$1"	## "B"  , "U"  , "A"  ## options for "local" control .
export gcCTBparam2="$2" ## "RS" , "RB" , "RQ" ## options to match manager "MGN.sh" .
export gcCTBparam3="$3"
case "${gcCTBparam1}" in	## capture param : 
	"B") gcCTBmode="B"  && gcCTBmodeName="Basic"   && gcCTBmodeId="CTB" ;;	
	"U") gcCTBmode="U"  && gcCTBmodeName="Utility" && gcCTBmodeId="CTU" ;;	
	"A") gcCTBmode="A"  && gcCTBmodeName="Auto"    && gcCTBmodeId="CTA" ;;	
	### *) 	gcCTBmode="U"	&& gcCTBmodeName="Utility" ;;	
	*) 	 gcCTBmode="B"	&& gcCTBmodeName="Basic" && gcCTBmodeId="CTB" ;;	
	### *)  	gcCTBmode="A"	&& gcCTBmodeName="Auto" ;;	
esac
. /etc/DISTRO_SPECS
. /etc/rc.d/PUPSTATE
export gcCTBmode="${gcCTBmode}"	## export a "gc-mode-control"
export gcCTBmodeName="${gcCTBmodeName}"	## export for "GUI display control" 2808
export gcCTBbackupSubDir="/CTB_Backup_"
export gcCtbZeroRun="$0"
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
gcCtbConfigFN="/CTB_config.sh"		# placed in '/' below '/root' 
if [ ! ${gcCTBmode} = "A" ] ; then	
	if [ -f ${gcCtbConfigFN} ]  ; then
		n=0
		gcCtbConfigTrgPrefix=""				# default null
		gcCtbConfigTrgPrefix=`cat ${gcCtbConfigFN}`
	else	
		lN=1
	fi
fi	# not [ ${gcCTBmode} = "A" ] 
	export gcCtbConfigTrgPrefix="${gcCtbConfigTrgPrefix}"
} # end: Sys_SetVerDts
function Sys_Str2DevTrm() {  # Active 
lcS2TStr=${1}   # STRING message 
lcS2TClr=${2}   # COLOR name or number
lcS2TMrg=${3}  	# MARGIN number 1,5,10 ... 2,3,4,5,etc
lcS2Topt=${4}	# "C"onsole  or  "T"erminal, Default is "User Defined" below. 
lcDevConsole=""  
lcS2Topt=${4}	## "C"onsole  or  "T"erminal
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;; ## not used by CTB 
   "T") lcDevConsole="" ;; ## "T"erminal display for Geany Execute Terminal 
    *)  lcDevConsole="" ;; ## default to Std Out is "T"erminal display
esac 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
case "${lcS2TClr}" in
		 ""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
		 *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; 
esac
	/bin/echo -n "$lcS2TStr"  ${lcDevConsole} 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
} # end: Sys_Str2DevTrm  
function CTB_ClearFlgLockFile {    #(:  Not Active
	n=0
    rm -f "${CTB_FlgLockFile}"   #   ClearFlag --- release 'Running' flag.
} # end: CTB_ClearFlgLockFile
function CTB_ClearFlgBugger_SD() {    #(:  not active
    #
	n=0
    rm -f "${CTB_FlgBugger_SD}" 
} # end: CTB_ClearFlgBugger_SD
function CTB_ClearFlgSys() {    #  active
	n=0
    rm -f "${CTB_FlgLockFile}"     #(: ClearFlags : release 'Running' flag.
    rm -f "${CTB_FlgBugger_SD}" 
    rm -f "${CTB_FlgBackupStatus}" 
    rm -f "/tmp/box_help"       #(: ClearFlags : used by fx HELP and fx FAQ  
    rm -f "/tmp/box_source"     #(: ClearFlags : used by fx SOURCE  
	rm -f /tmp/flagnextpassthru			#(:  from SMP or TarOpt
	rm -f /tmp/snapmergepuppy-error		#(:  from SMP
	rm -f /tmp/delayedrun_finished_flag	#(: during CTB, via call from MGN. 
} # end: CTB_ClearFlgSys
function Sbr_Box_Splash() {  # Not Active
    n=0
/usr/lib/gtkdialog/box_splash -fg ${2} -bg ${3} -close never -text "\
.     ${1}  "&
    RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!	# capture PID
} # end: Sbr_Box_Splash
function Sbr_Box_Message() {  # CTB Active called by HLP and FAQ
    n=0
export TEXTDOMAIN=libstardust
export OUTPUT_CHARSET=UTF-8
if [ "$1" ] ; then
	Box_Msg_Heading="${1}"	# parm #1 if sent. 
else	# else simple standard 'heading'.
	Box_Msg_Heading="$(gettext '---Sbr_Box_Message---')"
fi
export Box_MessageXML='
<window title="'!$Box_Msg_Heading'" default-height="550" default-width="750">
<vbox space-expand="true" space-fill="true">
  <vbox space-expand="true" space-fill="true">
    <vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
      <vbox space-expand="false" space-fill="false">
        <text xpad="10" ypad="15" use-markup="true"><input file>'/tmp/box_help'</input></text>
      </vbox>
    </vbox>
  </vbox>
  <hbox space-expand="false" space-fill="false">
    <button>
      '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
      <label>'$(gettext 'Ok')'</label>
    </button>
  </hbox>
</vbox>
</window>'
gtkdialog --center -p Box_MessageXML	# assumes /tmp/box_help
#
} # end: Sbr_Box_Message
########################################################################
function Sys_Box_HLP() {    #  CTB Active
    n=0
	lcFileHelpTxt="/tmp/box_help"	#(:  required by gtkdialog original source code. 
	#
    echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "====="</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"  CTB HLP "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "=====" </span></span>
<span foreground='"'green'"'>"  "  v: ${gcSysDevDob}"  "</span> " glene77is --- v.4 "
<b><span foreground='"'red'"'>"---------------------------------------------------------"</span></b>
<b><span foreground='"'red'"'>" 	Cold-Tar-Backup method is this  : "</span></b>
<b><span foreground='"'green'"'>" Click "BackUp" for simple single Backup "</span></b>
	or
<b><span foreground='"'red'"'>"IF you want to SCAN other HD "</span></b>
<b><span foreground='"'brown'"'>"... and cast Backup.tar.gz out to HD "</span></b>
<b><span foreground='"'brown'"'>"... into  "${gcCTBbackupSubDir}" "</span></b>
<b><span foreground='"'brown'"'>"THEN "</span></b>
<b><span foreground='"'brown'"'>"...   First:  click the SCAN button, "</span></b>
<b><span foreground='"'brown'"'>"...   Second: click the BACKUP button !"</span></b>
<b><span foreground='"'red'"'>"---------------------------------------------------------"</span></b>
<b><span foreground='"'red'"'>" IF you want to write the Tar.Gz file to SPECIAL subdir"</span></b>
<b><span foreground='"'brown'"'>"THEN write '/CTB_config.sh'  "</span></b>
<b><span foreground='"'brown'"'>"... Read method is 'cat' into 'var' "</span></b>
<b><span foreground='"'brown'"'>"... cat will pull out ALL contents"</span></b>
<b><span foreground='"'brown'"'>"...   including any embedded quote marks"</span></b>
<b><span foreground='"'brown'"'>"... good example is:   /mnt/home/   "</span></b>
<span foreground='"'red'"'>"CTB calls Tar.gz for fast backup "</span>
<b><span foreground='"'green'"'>"'TAR' the 'Unix Tape ARchive' method"</span></b>
<span foreground='"'blue'"'>"CTB is designed specifically for "</span>
<span foreground='"'red'"'>"    "Official" Puppy Linux"</span>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFOLDER"</span></b>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFILE.4fs"</span></b>
<b>1)</b> CTB <b>automatically appends
   the "DTS yr-mo-dy-seconds" stamp</b>
   to the Backup file .tar.gz name.
   This kills possible duplications !
<b>2)</b> CTB <b>automatically pre-Runs 
	"SnapMergePuppy"</b> to update/merge 
	the RAM into the 'saveDATA'.
<b><span foreground='"'darkred'"'>CTB will back-up from 'source'->'target'</span></b>
... exactly as prescribed in 'PUPSTATE'.
<b><span foreground='"'darkred'"'>CTB is controlled by the 'PUPSTATE' var</span></b>
... as written by the Puppy Linux OS .
<b><span foreground='"'darkred'"'>CTB 'PUPSTATE' contains the "State" values</span></b>
... of the currently running Puppy OS.
<b><span foreground='"'darkred'"'>CTB will use <span foreground='"'green'"'>'PUPSTATE'</span> data</span></b>
... to find the Source and Target .
<b><span foreground='"'darkred'"'>CTB can be <span foreground='"'green'"'>MODIFIED</span> to back-up</span></b>
... ANY 'source' to any 'target'.
<b><span foreground='"'darkred'"'>CTB can <span foreground='"'green'"'>SCAN list of Mounted hard-drives </span></span></b>
... Click the SCAN button at top of screen  
    to copy back-up onto alternate hard-drives
    into a folder named "${gcCTBbackupSubDir}" .
... User must Select option button 'SCAN' 
    on main splash screen .
<b><span foreground='"'darkred'"'>CTB can SCAN list of Mounted hard-drives </span></b>
... CTB can cast the Backup.tar.gz 
    out to SDA2 thru SDG1
    into a folder named "${gcCTBbackupSubDir}" .
... On our OS, limit is 8 hard-drives, 
    as mounted at bootup. 
... Limit is usually 8, 
    depends on BIOS hardware and OS distro. 
... Authors systems are MS-XP class computers,
      with bios dated 2009 thru 2012  
      so our limit is 8 .
... One secondary Backup Hard-Drive is sufficient.  
... Each target must have subdir at the "/home" level 
...    as "${gcCTBbackupSubDir}" . 
    for example "/mnt/sdc1""${gcCTBbackupSubDir}". 
    for example "/mnt/sdd1""${gcCTBbackupSubDir}". 
    for example "/mnt/sde1""${gcCTBbackupSubDir}". 
    for example "/mnt/sdf1""${gcCTBbackupSubDir}". 
To RESTORE:
''XArchive', will 'Extract all' from inside 
<b>saveDATA-CTB---tar.gz</b> file.
<b><span foreground='"'darkred'"'>"Note: When Running Executable BASH script :"</span></b>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.
... end of file 'HELP' text ..................................."\
> ${lcFileHelpTxt}   # /tmp/box_help	
Sbr_Box_Message "=${DISTRO_NAME} = HELP = gtk 'Sbr_Box_Message' and /tmp/box_help"
} #(: end: Sys_Help_Box
function Sys_Box_FAQ() {    #	Active
    n=0
	lcFileFaqTxt="/tmp/box_help"  #(:  required by gtkdialog original source code. 
    echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "====="</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"  CTB FAQ "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "=====" </span></span>
<span foreground='"'green'"'>"  "  v: ${gcSysDevDob}"  "</span> " author: Glen Ellis "
<span foreground='"'darkred'"'>" Statement of Dependencies " </span>
<span foreground='"'blue'"'>" CTB is written in BASH with gtkdialog 0.8.4 , 2007 " </span>
--- written by Laszlo Pere, Thunor, gtk-2 , 2007 .
<span foreground='"'blue'"'>" gxmessage-2.12.4 clone of xmessage, 2009 " </span>
--- written by Timothy Richard Musson , 2009 .
<span foreground='"'darkgreen'"'>" These are included in all "official" Puppy OS.  " </span>
<span foreground='"'red'"'>"CTB calls Tar.gz for fast backup "</span>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFOLDER"</span></b>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFILE.4fs"</span></b>
<span  background='"'white'"'foreground='"'green'"'>"Authors note about CTB design goal:"</span>
CTB code is  <span background='"'blue'"' foreground='"'yellow'"'>" documented "</span>
CTB code is  <span background='"'blue'"' foreground='"'yellow'"'>" modular "</span>
CTB code is  <span background='"'blue'"' foreground='"'yellow'"'>" modifiable "</span>
<span foreground='"'blue'"'>"CTB is designed for "</span>
<span foreground='"'red'"'>"    "Official" Puppy Linux"</span>
<span foreground='"'green'"'>"   32/64-bit Frugal" "\'saveFOLDER\' "</span>
<span foreground='"'green'"'>"   32/64-bit Frugal" "\'saveFILE.4fs\' "</span>
<span foreground='"'brown'"'># From the Puppy FAQ:  (quote)
.# Q: What is an "official" Puppy Linux distro ?
.# It must meet two conditions according to github : 
<span foreground='"'blue'"'>https://github.com/puppylinux-woof-CE/woof-CE </span>
<span foreground='"'red'"'>#  1) It must be built using Woof-CE </span>
<span foreground='"'brown'"'>#	and its build “recipe” should be in woof-distro. </span>
<span foreground='"'red'"'>#  2) It must be endorsed as “official” </span> 
<span foreground='"'brown'"'>#	by the "Puppy Master". </span>
.# (/quote) </span>
<span foreground='"'brown'"'>Non-Official Puppy distros </span>
<span foreground='"'brown'"'>     may have dependency issues. </span>
<b>1)</b> CTB <b>automatically appends
   the "DTS yr-mo-dy-seconds" stamp</b>
   to the Backup file .tar.gz name.
   This kills possible duplications !
<b>2)</b> CTB <b>automatically pre-Runs 
	"SnapMergePuppy"</b> to update/merge 
	the RAM into the 'saveDATA'.
<b><span foreground='"'darkred'"'>CTB</span>  is <span foreground='"'blue'"'>"written for "</span></b>
<span foreground='"'brown'"'><b>"'Puppy Linux Frugal installs: </b> 
(the Barry Kauler method) '"</span>
CTB <span foreground='"'green'"'>"will call 'SnapMergePuppy'"</span>
CTB <span foreground='"'green'"'>"will backup the current 'save-DATA'"</span>
CTB <span foreground='"'green'"'>"will call .tar.gz fast compression"</span>
CTB <span foreground='"'green'"'>"will append \'-CTB-Date/Time/Seconds\'"</span>
CTB has option for 'Help' notes / helpful hints. 
CTB has option for 'FAQ'  notes / helpful hints. 
CTB has option to  'cat'  the source code. 
CTB has option to  'splash' the Legal Message. 
<b><span foreground='"'darkred'"'>CTB will back-up from 'source'->'target'</span></b>
... exactly as prescribed in 'PUPSTATE'.
<b><span foreground='"'darkred'"'>CTB is controlled by the 'PUPSTATE' var</span></b>
... as written by the Puppy Linux OS .
<b><span foreground='"'darkred'"'>CTB 'PUPSTATE' contains the "State" values</span></b>
... of the currently running Puppy OS.
<b><span foreground='"'darkred'"'>CTB will use <span foreground='"'green'"'>'PUPSTATE'</span> data</span></b>
... to find the Source and Target .
<b><span foreground='"'darkred'"'>CTB can be <span foreground='"'green'"'>MODIFIED</span> to back-up</span></b>
... ANY 'source' to any 'target'.
<b><span foreground='"'darkred'"'>CTB can <span foreground='"'green'"'>SCAN list of Mounted hard-drives </span></span></b>
... to copy back-up onto alternate hard-drives
... into a folder named "${gcCTBbackupSubDir}" .
... Select option 'ScanData' on front splash screen .
... On our OS, limit is 8 hard-drives, as loaded at bootup. 
... Limit is usually 8, depends on BIOS date, and OS distro. 
... Each Scan Target must have subdir in the "/home" level 
...    as this subdir name "${gcCTBbackupSubDir}" . 
>>> note: 
.#(: Author aimed for the generic SDA1, SDB1, SDC1, et al 
.#(:	User can substitute any drive name, 
.#(:     even system networked drives. 
.#(: Enter new names in subroutine "CTB_Scan_All"
.#(:    Very Simple Method. 
.#(: "CTB" is the "B"asic version with GUI and SCAN options. 
.#(: We have "Auto" and "Utility" and "NoSMP-Auto" versions. 
.#(:    which skip all the Main Gui Screen control options.
.#(:	Other versions are controlled by user modifiable tags  
.#(:    in the f(Sys_SetVerDts) module 
.#(:    which is the first code module in this Source File.
.#(:
To restore:
''XArchive', will 'Extract all' from 
the <b>saveDATA-CTB---tar.gz</b> file.
<b><span foreground='"'red'"'>"---------------------------------------------------------"</span></b>
.#(:	NOTE: 
<b><span foreground='"'darkred'"'>#(: "CTB" is "Cold-Tar-Backup" </span></b>
.#(: based on "tar" and "gz" methods. 
.#(: features tar.gz.out file with DTS stamp 
.#(:		in Year-Month-Day-Seconds. 
.#(: features Scanning-BackUp-to-Multiple-Drives.
.#(:
.#(: Script name format is 'XXX.sh' so GEANY 
.#(:		(1) sees a 'script' executable file.
.#(:		(2) sees a 'script' with 'executable permission.
<b><span foreground='"'red'"'>"--------------------------------------"</span></b>
<b><span foreground='"'red'"'>" IF you want to SCAN other HD "</span></b>
<b><span foreground='"'brown'"'>"... and cast Backup.tar.gz out to HD "</span></b>
<b><span foreground='"'brown'"'>"... into  "${gcCTBbackupSubDir}" "</span></b>
<b><span foreground='"'brown'"'>"THEN "</span></b>
<b><span foreground='"'brown'"'>"...   First:  click the SCAN button, "</span></b>
<b><span foreground='"'brown'"'>"...   Second: click the BACKUP button !"</span></b>
<b><span foreground='"'red'"'>"-----------------------------------------------------------------"</span></b>
<b><span foreground='"'red'"'>" IF you want to write the Tar.Gz file to SPECIAL subdir"</span></b>
<b><span foreground='"'brown'"'>"THEN write '/CTB_config.sh'  "</span></b>
<b><span foreground='"'brown'"'>"...  Read method is 'cat' into 'var' "</span></b>
<b><span foreground='"'brown'"'>"...  cat will pull out ALL contents"</span></b>
<b><span foreground='"'brown'"'>"...     including any embedded quote marks"</span></b>
<b><span foreground='"'brown'"'>"...  do NOT specify any location in the RAM system."</span></b>
<b><span foreground='"'brown'"'>"...    as this will be included in the saveDATA archive."</span></b>
<b><span foreground='"'brown'"'>"...  Always specify a location on a Hard-Drive."</span></b>
<b><span foreground='"'brown'"'>"...  Good example is:   /mnt/home/  "</span></b>
<b><span foreground='"'darkred'"'>.#(:  Note: </span></b>
. <b><span foreground='"'darkred'"'>'PUPSTATE' file contains 'PUPSAVE' </span></b>
.	as the name of the saveDATA in use !
.	System Var in CTB are all pulled 
.	(1)   from PUPSTATE for system constants 
.	(2)   from DISTRO_SPECS for system constants
. CTB is dependent only on gtkdialog and xmessage 
.
. Barry Kauler code method is used 
.	for extracting "home" subdir of saveDATA . 
.	which , in author's case, is 
.	/initrd/mnt/dev_save
.		/pup_UpupBB-sda/upupBB+29+ram
.
<b><span foreground='"'red'"'>".---------------------------------------------------------"</span></b>
.<b><span foreground='"'darkred'"'> saveDATA can be  </span></b>
.	<b><span foreground='"'darkred'"'>"/FILE" </span></b> ./?fs file
.	or  
.	<b><span foreground='"'darkred'"'>"/FOLDER"</span></b> subdir .
.
. CTB takes the savedata as Source name 
.	and runs it thru Tar.Gz .
.	.tar.gz does not care what kind 
.	of file or folder is Source Data.
. 	.tar.gz will read any file type. 
. CTB can be re-writen to backup from 
.	PDF,Tar.gz,LZO, etc, or .2fs, 3fs, 4fs, etc. 
> <b><span foreground='"'darkred'"'>begin: the BK method"!'</span></b> 
> <b><span foreground='"'red'"'>Note about specifying 
	the "System Location" :</span></b>
> Is it "/initrd/mnt/dev_save" or "/mnt/home" ??? 
> May depend on how the system is booted and running: 
> 	(1) Hard-Drive boot and running on Hard-Drive
> 	(2) USB-Flash-Drive boot and running on Hard-Drive.
> 	(3) USB-Flash-Drive boot and running on USB-Flash-Drive.
> <b><span foreground='"'darkred'"'>Barry Kauler calculated </span></b>
>      the "system saveDATA location" this way : 
>> <span foreground='"'green'"'>SaveFileNameMount  </span>
 ="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
>> <span foreground='"'blue'"'>SaveFileNameBaseSrc  </span> 
 ="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
>> BK calcs are performed : 
   (1) after 'system' has booted  
   (2) after 'aufs' is running  
> <b><span foreground='"'darkred'"'>end: the BK method"!"</span></b> 
>> Authors "Primary" Puppy OS (8) are 
> on the "primary" Hard-Drive ( sda1 ) 
> as '/initrd/mnt/dev_save' on boot-up
> not as '/mnt/home' . 
> (1) We use the USB boot method 
> to mount the Puppy OS on sda1 
> which is becomes our Primary HD. 
> also
> (2) We use the USB boot method 
> to mount the Puppy OS on USB 
> as our Primary HD. Portable. 
> 
<b><span foreground='"'darkred'"'>"Note on running executable BASH script :"</span></b>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.
... BASH ...
CTB is written in BASH, Bjourne Again SHell, which is 
... built on Unix '"korn"' shell, 
... built on '"A"' '"B"' '"C"' '"T"' '"Z"' shells,  
... and BASH is a Unix-like script language 
... intended to provide system management control.  
... not intended for developing system applications. 
CTB is written in BASH, 
... with some help from gtkdialog for GUI.
<b><span foreground='"'darkred'"'>"Geany Debug Method :"</span></b>
 We use the Geany Execute process 
 which calls the 'BASH terminal' 
 to activate this script and 
 run it in 'BASH-Terminal' 
 so to provide trace/debug options .
All 'echo' commands will display for tracing.
'CTB.sh' name format so GEANY sees a 'script' .
'rc.z_CTB.sh' indicates a preferred 
 location of script on 'turnkey' systems.
<b><span foreground='"'darkred'"'>" NOTE: the CTB Lock-File method." </span></b>
<span foreground='"'green'"'>".   Always: " </span>
 CTB will has a <span foreground='"'darkred'"'>"Soft-Lockout"</span> 
 via a "Warning" Dialog only,
    and then it will fall thru to rest of program.
 The user should "QUIT" and restart "CTB" . 
 <span foreground='"'green'"'>".   Possibly: " </span>
 the user will decide to continue 'CTB',
 ... ignoring the warning (this is what authors do). 
 'CTB' will continue properly.
 ... there will be <span foreground='"'darkred'"'>NO fatal fault,</span>
<b><span foreground='"'darkred'"'>" NOTE: the saveDATA refresh method." </span></b>
 ... CTB always runs "snapmergepuppy nice -19" 
 ...... to give <b>top priority to re-fresh saveDATA</b>, 
 ......   before "TarOpt" process. 
.
.<b> <span foreground='"'darkred'"'>This CAVEAT: </span></b>
. <span foreground='"'red'"'>"Do Not Un-Plug the Flash Drives !"</span>
. <span foreground='"'green'"'>"because they may still be buffering data"</span>
. <span foreground='"'green'"'>"into the final storage blocks on the chip."</span>
. <span foreground='"'red'"'>"Do Call" <span foreground='"'purple'"'>"'pmount'"</span> 
.	"to handle the Flash Drives !"</span>
.
<span foreground='"'darkblue'"'>
.#(:---------------------------------------------------------------
.#(:  output '"HELP"' and '"FAQ"' temp file 
.#(:       MUST BE '"/tmp/box_help"' 
.#(:       due to hard-code in '"gtkdialog/box_help"'.
.#(:---------------------------------------------------------------</span>
<span foreground='"'darkgreen'"'>.#(: fx(Sbr_Box_Message)	
.#(: called by : f(Sys_Box_HLP) and f(Sys_Box_FAQ)
.#(: receives param : parm$1 and '/tmp/box_help'
.#(: purpose : custom Simple Message subroutine  
.#(:   based on "gtkdialog -p" box_help code processes.
.#(:---------------------------------------------------------------</span>
  
These CTB modules will run, and 'ReStart' this program. 
... '"Help"'    '"Faq"'   ... '"Source"'  ... '"Legal"' 
''User'' should Run '"CTB"' script 
...    in '"Geany"' or '"ROX"' '"terminal"'
...    to view/trace actions of internal operations !
.#(:
.#(:----------------------------------------------------
.#(:
.#(: "MGR.sh system" 
.#(:	 Author's system 
.#(: ( rc.z_MGN.sh 9Kbytes bash, E2R.sh, CTB.sh, S2F.sh, etc. ) 
.#(:	is located/edited in the Development subdir: 
.#(:		'/initrd/mnt/dev_save/MY_/usr-share/My_Dev_'
.#(:     but can be located anywhere. 
.#(: ok to rename "CTB.sh" to "ColdTarBackup.sh" 
.#(: ok to rename to anything the user likes. 
.#(: ok to install anywhere, 
.#(:	ok to activate via desktop icon.
.#(:
.#(: "Developed using Geany" :
.#(: 	with option "Execute" in "BASH Terminal" 
.#(:  Using Geany with option "Execute" 
.#(:    (1) activates "BASH Trace/Debug" mode. 
.#(:    (2) maintains a ctrl"Z" restore process. 
.#(:    (3) allows monitoring "BASH quirks". 
.#(:
.#(:	"Messages to screen" : 
.#(: 	All of our "echo" lines will show 'B/W' trace
.#(:			in the BASH Terminal screen.
.#(: 	All of our "Sys_Str2DevTrm" lines show 'Color' trace
.#(:			in the BASH Terminal screen.
.#(:
.#(: Author's "/Development"  vs.  "/Production" subdirs: 
.#(:      "/Development" = 
.#(:  "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/..."
.#(:      "/Production" = 
.#(:  "/root/my-applications" 
.#(:       and is backed-up with 'save2flash' in saveDATA . 
.#(:  We maintain separation between 
.#(:  "Dev/Edit" and "Production-Final" . 
.#(:  OK to rename to "ColdTarBackup.sh" or anything else. 
.#(:  OK to install anywhere, and 'run' via desktop icon .
.#(: 
.#(: "Development/Edit" files:
.#(:		 in "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/..." .
.#(: (1) run "MGR.sh" to activate the utilities 
.#(:		located in "Development" subdir .
.#(: (2) run "E2R.sh" to copy "Development" versions  
.#(:		into "/root/my-applications" .
.#(: (3) store apps/scripts in "/root/my-applications" 
.#(:		thus to archive via "Save2Flash" 
.#(:		into "saveDATA" user 'layer'. 
.#(: (4) this maintains separation: 
.#(:      "/DEVELOPMENT" vs "/PRODUCTION" .
.#(:
.#(: 
<span background='"'blue'"' foreground='"'white'"'>"NOTE: BASH process stack "</span>
.#(:  Repeated "ReStart" on "CTB"
.#(:         will load process stack cumulatively. 
.#(:  On '"Quit"' and '"exit 0"' the process stack 
.#(:         will pop, revealing one level at a time. 
.#(:   This is a BASH stacking control quirk, 
.#(:   Events of this type occur in "snapmergepuppy" 
.#(:      as it searches for more data to include 
.#(:      in the "merge" process. 		
.#(:	 All this because BASH is a system command processor
.#(:      not a program application language.        
.#(:----------------------------------------------------
.#(:	NOTE: 
.#(:    BASH stack-popping event notifications. 
.#(:
.#(:   IF user selects "Scan", "Help", "FAQ", "Source" 
.#(:		 from top of main page. 
.#(:   THEN a "stack popping" event will occur .
.#(:   EVIDENCE shows in terminal "QUIT" screen 
.#(:	     as a succession of "un-popping" messages. 
.#(:   Same thing occured in 'rc.sysinit' in TAHR 6.0 
.#(:      This is a BASH quirk.  
.#(:   Events of this type occur in "snapmergepuppy" 
.#(:      as it searches for more data to include 
.#(:      in the "merge" process. 		
.#(:   
<b><span foreground='"'green'"'>"BASH is a Unix-like script language."</span></b>
<b><span foreground='"'green'"'>"BASH is a system command processor "</span></b>
<b><span foreground='"'green'"'>"BASH does not support Strict Typing" </span></b>
<b><span foreground='"'green'"'>"BASH does not support Inheritance" </span></b>
<b><span foreground='"'green'"'>"BASH does not support Encapsulation" </span></b>
<b><span foreground='"'green'"'>"BASH does not support Polymorphism" </span></b>
<b><span foreground='"'green'"'>"BASH does not support Data Abstraction" </span></b>
<b><span foreground='"'green'"'>"BASH is BASH "</span></b>
... end of 'FAQ' text ........................................"\
> "${lcFileFaqTxt}" 
Sbr_Box_Message "=${DISTRO_NAME}= FAQ = gtk 'Sbr_Box_Message' and /tmp/box_help"
} # end: Sys_Box_FAQ
function Sys_Box_SRC() {    #(:  active
    n=0
lcFileTrgTxt="/tmp/box_help"   # remains in /tmp until "CTB" is "QUIT" closed. 
lcFileXmessage="/usr/bin/xmessage"
lcFileGXmessage="/usr/bin/gxmessage"
if [ ! -f "/usr/bin/gxmessage" ] ; then 
	lcMsgStr="===  Sys_Dump_SRC gxmessage === "  &&     Sys_Str2DevTrm "$lcMsgStr" "3" "7" 
	lcMsgStr="===  /usr/bin/gxmessage is missing === "  &&     Sys_Str2DevTrm "$lcMsgStr" "3" "7" 
/usr/lib/gtkdialog/box_splash -fg yellow -bg red -border true -close never -text "\
.
.     Not Found! /usr/bin/gxmessage !!!      
. "&
	sleep 3
    RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!	# capture PID
	kill ${GtkPid_Sbr_Box_Splash} # after return
	#
    return 
	#
else
	lcMsgStr="===  Sys_Dump_SRC gxmessage === "  &&     Sys_Str2DevTrm "$lcMsgStr" "3" "7" 
	lcMsgStr="===  /usr/bin/gxmessage is OK === "  &&     Sys_Str2DevTrm "$lcMsgStr" "3" "7" 
fi
echo "Source_Dump    "  							>    ${lcFileTrgTxt} 
echo "'/tmp/box_help'  via  /usr/bin/gxmessage "  	>>    ${lcFileTrgTxt} 
echo "${DISTRO_NAME} ${DISTRO_VERSION} ${DISTRO_SUFFIX}" >>    ${lcFileTrgTxt} 
echo "  v: ${gcSysDevDob}  glene77is --- v.4.1 "   	>>    ${lcFileTrgTxt} 
echo " "  >>    ${lcFileTrgTxt} 
cat ${0} >> ${lcFileTrgTxt}     # cat 
echo "Cold-Tar-Backup 'CTB' Source_Dump    "  >>    ${lcFileTrgTxt} 
echo "${DISTRO_NAME} '/tmp/box_help' is Source_Dump    "  >>    ${lcFileTrgTxt} 
echo "remains in /tmp until 'CTB''SRC' is 'OK' button to 'QUIT' "  >>    ${lcFileTrgTxt} 
echo "/usr/bin/gxmessage" >>    ${lcFileTrgTxt} 
gxmessage -name "${DISTRO_NAME} '/tmp/box_help' gxmessage Source_Dump"  -bg lightyellow  -center -file ${lcFileTrgTxt} -wrap
sleep .3    # gxmessage only returns properly via the "OK" button.  
#
} # end: Sys_Box_SRC
function Sys_Box_UPL() {	# Active 
    n=0
lcStrUPL="
.
	Legal notice subroutine developed by peebee 
	- https://sourceforge.net/u/peabee/profile/
.
	This program is free software; 
	you can redistribute it 
	and/or modify it 
	under the terms of the GNU General Public License 
	as published by the Free Software Foundation.
.
	This program is distributed in the hope 
	that it will be useful,
	but WITHOUT ANY WARRANTY; 
	without even 
	the implied warranty of MERCHANTABILITY 
	or FITNESS FOR A PARTICULAR PURPOSE.  
	See the GNU General Public License 
	for more details.
.	"
/usr/lib/gtkdialog/box_ok "=${DISTRO_NAME}= gtk  Legal Message" info "${lcStrUPL}"
	#
sleep .3
	#
} # end: Sys_Box_UPL
function Sys_PupState() {    #(:  active
tcVerDtsTmpPS="${gcSysDevDob}"  # before PUPSTATE
. /etc/rc.d/PUPSTATE
gcSysDevDob="${tcVerDtsTmpPS}"  # after PUPSTATE
gcCtbDts=""
export gcCtbDts="`date +%y%m%d-%H%M-%S`"   #(:  was gcSysDts
lcPupSave=${PUPSAVE}
lcPupMode=${PUPMODE}
lcPupSubDir=${PSUBDIR}
lcPupHome=${PUP_HOME}
lcMsgStr="build-std: maintain similarity to PUPSTATE" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
lcPupSaveNamePUPSAVE="PUPSAVE : ${PUPSAVE}"  # CTB 'raw' savefilename from PUPSTATE file
lcMsgStr="build-std:lcPupSaveNamePUPSAVE: ${lcPupSaveNamePUPSAVE}" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
lcPupSaveNameCut="`echo $lcPupSave | cut -f 3 -d "/"`" # CTB 'cut' savefilename from PUPSTATE file
lcMsgStr="build-std: lcPupSaveNameCut: ${lcPupSaveNameCut}" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
lcPupSaveNameSrc="${lcPupSaveNameCut}"
lcMsgStr="build-std: lcPupSaveNameSrc: ${lcPupSaveNameSrc}" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
lcMsgStr="build BK method into TarOpt"  && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
export lcPupSaveNameAufs="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
export lcPupSaveNameSrc="${lcPupSaveNameAufs##*/}"  # currently, this shows in gui display
lcPupSaveNameAufsBK="lcPupSaveNameAufs"	# long full BK extraction
lcPupSaveNameSrcBK="lcPupSaveNameSrc"	# to display FileNameSRC on main Red Splash screen 
lcMsgStr="lcPupSaveNameAufsBK : ${lcPupSaveNameAufs}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
lcMsgStr="lcPupSaveNameSrcBK : ${lcPupSaveNameSrc}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
lcMsgStr="build-std: date-time-seconds string" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
lcFileNameDTS="/0-CTB-DTS"
touch -f "${lcFileNameDTS}"	#(:  record sysDTS marker
lcPupSaveNameTrgTmp="${lcPupSaveNameSrc}-CTB-`date +%y%m%d-%H%M-%S`"     
lcPupSaveNameTrg="${lcPupSaveNameTrgTmp}.tar.gz"
export gcCtbDistroVer=${gcSysDistroVer}
export gcCtbKernVer="`uname -r`"	 
lcMsgStr="PupSaveNameRaw : ${lcPupSaveNameRaw}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
} # end: Sys_PupState
function CTB_ReStart() {    #(:  active
#
lcMsgStr="*** ClearFlgLockFile" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
rm -f "${CTB_FlgLockFile}"     #(:  ClearFlags --- release 'Running' flag.
lcMsgStr="*** ClearFlgBackupStatus" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
rm -f "${CTB_FlgBackupStatus}" 
${gcCtbZeroRun}      
} # end: CTB_ReStart
 
function CTB_StartUp() {    #(:  active
Sys_SetVerDts   
Sys_PupState        
lcSaveData="`echo $lcPupSave | cut -f 3 -d ","`"
export CTB="CTB"	# entered by Dev at top of source code. 
export CTB_REFRESH_INTERVAL=1000 
export CTB_FlgBugger_SD="/tmp/CTB_FlgBugger_SD"
export CTB_BackUpStatus="/tmp/CTB_BackUp_Status"
export CTB_FlgLockFile="/tmp/CTB_FlgLockFile"
export CTB_PupSaveDataName="/mnt/home"`grep PUPSAVE /etc/rc.d/PUPSTATE | cut -f 3 -d "," | cut -f 1 -d "'" ` 
export CTB_PUPSAVE_PATH="/mnt/home${lcSaveData}"
export -f Sys_Box_HLP   
export -f Sys_Box_SRC 
export -f Sys_Str2DevTrm
export -f  CTB_TrgFilename
export -f  CTB_ReStart
export -f  CTB_ScanList
export -f  CTB_ScanOne
export -f CTB_ClearFlgSys
export -f CTB_ClearFlgLockFile
export -f CTB_ClearFlgBugger_SD
export -f  CTB_BackUpRun
echo "" > /dev/console	#(:  bump the running/trace terminal window display . 
aa="$(du -c -m -s ${CTB_PupSaveDataName} )"     
read -r b ccc <<< "$aa"
lcPupRamObj="${b}"
export lcPupRamObjMsg=" # Source saveDATA Size : ${lcPupRamObj} MB # "
echo "" > /dev/console
} # end: CTB_StartUp
function CTB_TrgFilename() {   # Active on main gui splash
    n=0
lcMsgSpacer="           : " #  used for display spacer on gui screen.
echo -n " ${lcMsgSpacer} Backup DTS .ext : -CTB-`date +%y%m%d-%H%M-%S`        "  
} # end: CTB_TrgFilename
function CTB_ScanOne() {     #(:  Active
lcBucSaveNameSrc=${1}      
lcBucSaveNameAls=${2}      
lcBucSaveNameDirTrg=${3}      
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
lcMsgStr=">>>  CTB_ScanOne  with {$lcBucSaveNameAls} >>>" && Sys_Str2DevTrm "$lcMsgStr" "5" "0"
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
/bin/echo -en "\\033[0;39m"     >  /dev/console #(:  color clear
/bin/echo -en "\\033[70G"    >/dev/console 
/bin/echo -en "\\033[1;33m "    >/dev/console 
/bin/echo -e  "\\033[0;39m"   >/dev/console 
n=0
lcBucSubDirTrgBaseAll="CTB_Backup_"
#
lcBucPSaveNameDts="`date +%y%m%d-%H%M-%S`"  #(:  "now" DTS 
### lcBucPSaveNameRaw="${lcPupSave}"  # 'raw' savefilename from PUPSTATE file
### lcPupSaveNameBasic="`echo $lcPupSave | cut -f 3 -d "/"`"  #(:  at this point in evolution. 
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ -f "${CTB_FlgBugger_SD}" ]  || [ ${gcCTBmode} = "A" ]  ; then # Control Scan
    lcBackOneStatusSD="SD"  #(:  Normal First Run Label
	lnScanOneOk=1	# used in next block
else
	lnScanOneOk=0
fi
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ ${lnScanOneOk} -eq 1 ] ; then 	
xmessage  -title "Scan-One-Status" -name 'CTB' -timeout 3 -center -bg yellow -fg blue " seeking ? ${lcBucSaveNameAls}  "
	lcFileOutDir="/mnt/${lcBucSaveNameAls}/${lcBucSubDirTrgBaseAll_}"
	lcMsgStr="DirTrg All :${lcFileOutDir}:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
	#
	if  [ -d ${lcFileOutDir} ]  ; then  	#(:  if Find Directory 
		lcFileIN="${lcTarOptSaveNameTrg}"  #(:  directly from "TarOpt"  tarptit
		lcFileOutDir="/mnt/${lcBucSaveNameAls}/${lcBucSubDirTrgBaseAll}"
		lcMsgStr="DirTrg All :${lcFileOutDir}:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
		lcMsgGtk="--- saveDATA <<< ${lcBucSaveNameAls} >>>>"
		if  [ -d ${lcFileOutDir} ] ; then 
			lcMsgStr="IN:$lcFileIN:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"       #(:  terminal trace
			lcMsgStr="OUT:< ${lcFileOutDir} >:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"  #(:  terminal trace
			lcMsgStr="< $lcMsgGtk >:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"  #(:  terminal trace
/usr/lib/gtkdialog/box_splash -fg red -bg lightgreen   -close never -text ":Find SubDir OK: ${lcBucSaveNameAls}:" &
			GTKPIDFC=$!
			sleep .5
				cp -r  ${lcFileIN} ${lcFileOutDir}
			sleep 1
			kill ${GTKPIDFC}
		else
			lcMsgStr=":<>:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"       #(:  terminal trace
			lcMsgStr="OUT:<No-Copy>:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"  #(:  terminal trace
			lcMsgStr=":<>:" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"  #(:  terminal trace
/usr/lib/gtkdialog/box_splash -fg blue -bg lightgreen   -close never -text ":?: ${lcBucSaveNameAls}:" &
			GTKPIDFC=$!
			sleep 1
			kill ${GTKPIDFC}
		fi #  [ -d ${lcFileOutDir} ] 
	else
		n=0
	fi  #(:  [ -d ${lcFileOutDir} ] 
	kill ${GTKPIDSOM}   #(:  clear Scan One Main 
	
fi  # end:  if [ ${lnScanOneOk} -eq 1 ] ; then 	
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
lcMsgStr="<<<  CTB_ScanOne  {$lcBucSaveNameAls} <<<" && Sys_Str2DevTrm "$lcMsgStr" "5" "0"
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
} # end: CTB_ScanOne
function CTB_ScanList() {     #(:  Active
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
lcMsgStr=">>> f(CTB-BKP_ScanList)--- local ---------------" && Sys_Str2DevTrm "$lcMsgStr" "2" "0"
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
    
lcBkpSaveNameSrc="${lcPupSaveNameTrg}"  #(:  from TarOpt process
 
export lcBkpSaveNameDirTrg="${gcCTBbackupSubDir}"	# "CTB_Backup_"
	lcBkpSaveNameAls="sda2"     #(:  Prefix name
	CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sda3"     #(:  Prefix name #(:  not in this system 
	CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sdb1"         #(:  Prefix name
	CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sdb2"         #(:  Prefix name
	CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sdc1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sdc2"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sdd1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
	lcBkpSaveNameAls="sde1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdf1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdg1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdh1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdi1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdj1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
    lcBkpSaveNameAls="sdk1"         #(:  Prefix name
    CTB_ScanOne ${lcBkpSaveNameSrc} ${lcBkpSaveNameAls} ${lcBkpSaveNameDirTrg}
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
lcMsgStr="<<< f(CTB-BKP_ScanList)--- local ---------------" && Sys_Str2DevTrm "$lcMsgStr" "2" "0"
lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr"
} # end: CTB_ScanList
function CTB_BackUpRun() {    #(:  Active CTB_Backup "TarOpt" 
    	n=0
    lcRunParStr=${1}	#  from f(CTB_BackUpRun)
    lcRunParStr=${2}	#  from f(CTB_BackUpRun)
lcMsgStr="--- CTB Running Backup ---"
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -border true  -close never \
-text " 
.              ${lcMsgStr}              
.
.
.
.
.
" &
		GTKPIDRUNNING=$!
		sleep 1  
lcMsgStr=">>> SYNC <<<"
/usr/lib/gtkdialog/box_splash -fg blue -bg lightgreen -border true  -close never \
-text "     $lcMsgStr   " &
		GTKPIDSYNC=$!
		sleep 1.5  
    sync    
	kill $GTKPIDSYNC
    Sys_SMP #(:  calls for splash and  "nice -## SnapMergePuppy" 
    
	kill $GTKPIDRUNNING		
        PWDir="$PWD"
        lcMsgStr="+++CTB_BackUpRun =========================================" && Sys_Str2DevTrm   "${lcMsgStr}"   "4" "3"
        lcMsgStr=">>> $ { 1% } is ${1} <<< param #1" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        lcMsgStr=">>> $ { 1% /* } is ${1%/*} <<< subdir of source saveDATA" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        lcMsgStr="PWDir points to '/root' path level (sys var) <" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        lcMsgStr="CWDir=PWdir : $PWdir  <" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        lcMsgStr="+++CTB_BackUpRun =========================================" && Sys_Str2DevTrm   "${lcMsgStr}"   "4" "3"
        CWDir=$PWDir  #(:  Swap Working Directories, /Root into /Current . 
    #
    lcDialogColor="  -fg yellow -bg darkred  "	# Splash Main 
    lcMsgStr="DialogColor: ${lcDialogColor} =======" && Sys_Str2DevTrm   "${lcMsgStr}"   "2" "3"
lcMsgStr="  MAIN Splash BackGround ... Tar from : ${1%/*}" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
/usr/lib/gtkdialog/box_splash ${lcDialogColor} -border true  -close never -text "
.     ... Please Wait ... ${gcSysDevDob} ... ${gcCTBmodeName}
.  Cold-Tar-Backup is Creating 'tar.gz' BackUp
.    Source saveDATA Size > ${lcPupRamObj} MB
.    Source File:  ^${lcPupSaveNameSrc}^
.
.
.
.              ... Progress Dialog ...
.
.
.
.
         TarOut: ${gcCtbConfigTrgPrefix}
 ${lcPupSaveNameTrg##*/} :
.
" &
GTKPIDTOP=$!    #(:  This is the Main "BackGround" screen.
sleep 2
	lcMsgStr="<<< cd ${1%/*} >>>" && Sys_Str2DevTrm   "${lcMsgStr}"   "1" "3"
	cd ${1%/*} #(:  dirname $CTB_PUPSAVE_PATH   <<< loc of saveDATA
lcDialogColor="  -fg yellow -bg green "
lcMsgStr="CTB < Tar Running > ${gcCTBmodeName}" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text "
$lcMsgStr  
		 " &
			GTKPIDRUNNING=$!
			sleep .5
	
	n=0
	lcTarRetVal=0	#(:  default preset parameters 
	export lcTarOptSaveNameSrc="${lcPupSaveNameSrc}"
#	export lcTarOptSaveNameTrg="${gcCtbConfigTrgPrefix}${lcPupSaveNameTrg}"		# apply New SubDir here !
#	export lcTarOptSaveNameTrg="/mnt/home/${lcPupSaveNameTrg}"		# writes to '/mnt/home/' 
	export lcTarOptSaveNameTrg="${gcCtbConfigTrgPrefix}${lcPupSaveNameTrg}"		# apply Config SubDir here !
        lcMsgStr="-----------------------------" && Sys_Str2DevTrm "$lcMsgStr" "4" "3"
        lcMsgStr=">>> begin TarOpt process" && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
        lcMsgStr="Src: ${lcTarOptSaveNameSrc}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
        lcMsgStr="Trg: ${lcTarOptSaveNameTrg}" && Sys_Str2DevTrm "$lcMsgStr" "5" "2"
        lcMsgStr="-----------------------------" && Sys_Str2DevTrm "$lcMsgStr" "4" "3"
        /bin/echo -n -e "\\033[1;36m" 
	TAROPT="-c -z --checkpoint=1000" #(: ----'c'reate 'v'erbose 'z'ip)
		tar ${TAROPT} -f ${lcTarOptSaveNameTrg} ${lcTarOptSaveNameSrc} 
		lcTarRetVal=0	
		lcTarRetVal=$?  #  capture Return Value of "0" or "1" into local var.
		rm -f /tmp/flagnextpassthru	   # after TarOpt 
        lcMsgStr="<<< End:  TarOpt process" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        echo
        /bin/echo -e "\\033[0;m" 
        sleep 1
        kill ${GTKPIDRUNNING}  
		
        
        aa="$(du -c -m -s ${lcTarOptSaveNameTrg} )"     
        read -r b ccc <<< "$aa"
        lcMsgStr="ccc:${ccc}" &&  Sys_Str2DevTrm "$lcMsgStr" "2" "3"
        lcMsgStr="b: ${b}" &&  Sys_Str2DevTrm "$lcMsgStr" "2" "3"
        lcPupRamObjStr="${b}" 
        lcMsgTos="tar-out-size :${lcPupRamObjStr}: MB" && Sys_Str2DevTrm "$lcMsgTos" "2" "3"
		#
		gcCTBerror="0"	# this will control the ScanList process. 
        if [ ${lcTarRetVal} -eq 1 ] ; then	 # based on local var lcTarRetVal 
            #
			gcCTBerror="1"	# this event will kill the ScanList process. 
            lcMsgStr="Error:  [ ${lcTarRetVal} -eq '1'"  && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
lcMsgStr="... Tar Process Message Error : 'File NOT Found' / 'InValid' ..." && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
lcDialogColor="  -fg yellow -bg blue  "
/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text "
 $lcMsgStr :$lcMsgTos:    
                    		 " &
GTKPIDtpem=${!}
sleep 5
kill "${GTKPIDtpem}"
        else
            lcMsgStr="else NOT [ ${lcTarRetVal} -eq '1'"  && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
			gcCTBerror="0"	# this will enable the ScanList process. 
        fi
lcMsgStr=" Tar < DONE > " && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
lcDialogColor="  -fg yellow -bg red  "
/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text " 
.
.     $lcMsgStr :$lcMsgTos:     
.                                " &
GTKPIDdone=${!}
sleep 1
kill "${GTKPIDdone}"
lcDialogColor="  -fg yellow -bg green  "
/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text " 
.
.     $lcMsgStr :$lcMsgTos:     
.                                " &
GTKPIDdone=${!}
sleep 1
kill "${GTKPIDdone}"
lcDialogColor="  -fg yellow -bg blue  "
/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text " 
.
.     $lcMsgStr :$lcMsgTos:     
.                                " &
GTKPIDdone=${!}
sleep 5
kill "${GTKPIDdone}"
#
		lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
		lcMsgStr=">>> before fx(CTB_ScanList) " && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
				if [ ${gcCTBerror} = "0" ] ; then	# "0" is ok  ( "1" is error 'file not found' )
                    if [ lcSetCtrl ] ; then
                        set +e
                    fi
					if [ -f ${CTB_FlgBugger_SD} ]  || [ ${gcCTBmode} = "A" ] ; then 
							CTB_ScanList    
						#
						lcMsgStr="*** ClearFlgBugger_SD" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
						rm -f "${CTB_FlgBugger_SD}" 
					else
						lndummy=0
						lcMsgStr="***  Bugger and mode flags not set" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
					fi
				else
					n=0
					lcMsgStr=" Tar < ERROR > file not found" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
					lcDialogColor="  -fg yellow -bg red  "
					/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text "$lcMsgStr" &
					GTKPIDerror=${!}
					sleep 7
					kill ${GTKPIDerror}
					echo "==========> kill $GTKPIDerror ---"
                    if [ lcSetCtrl ] ; then
                        set -e
                    fi
				fi #  [ ${gcCTBerror} = "0" ]  
				lcMsgStr="<<< after fx(CTB_ScanList) " && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
				lcMsgStr=" " && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
        lcMsgStr="cd  CWDir= $ CWDir  is $CWDir <<<" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        lcMsgStr="cd  orig subdir in long 'path' form <<<" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        cd "$CWDir" #(:  point back to /root
        lcMsgStr="change dir 'CWDir' ... point back to /root dir " && Sys_Str2DevTrm   "${lcMsgStr}"   "2" "3"
		sleep .1
		kill ${GTKPIDTOP}
		echo "==========> kill $GTKPIDTOP ---"
	rm -f "${CTB_FlgLockFile}"  
	CTB_ClearFlgSys	#(:  end: fx(CTB_BackUpRun)
    touch  "${CTB_BackUpStatus}"   # set STATUS flag to "active"
	#
} # end: CTB_BackUpRun
#(! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_SMP() {    # ACTIVE snapmergepuppy
n=0
lcRunNum="19"
lcRunSeq="1"
lcDialogColorBg="  -fg red -bg black "  # background
lcMsgStr="${gcCTBmodeId} SnapMergePuppy nice -n ${lcRunNum}  [${lcRunSeq}]"
/usr/lib/gtkdialog/box_splash ${lcDialogColorBg} -border true -close never -text "$lcMsgStr" &
		GTKPIDSMP1=$!
		sleep .5  
lcDialogColorFg="  -fg yellow    -bg black "  # foreground
lcRunNum="19"
lcLoopCnt="3"
if [ ! -s ${lcLoopCnt} ] ; then 
    ii=${lcLoopCnt}
else
    ii=1
fi
for (( i = 1; i <= $ii ; i++ )) ## "C"syntax "C" syntax 'C'syntax 'C' syntax
do 
    n=0
    lcMsgStr=" <$i>  nice -n ${lcRunNum} SnapMergePuppy"  # foreground 
    /usr/lib/gtkdialog/box_splash ${lcDialogColorFg} -border true -close never -text ".  $lcMsgStr  ." &
    GTKPIDSMP0=$!
        nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw    1>/dev/null 2>&1 
    sleep .2    # expose splash during SMP
    kill $GTKPIDSMP0
done # end: for (( i = 1; i <= $ii ; i++ ))
#(
#(######################################################################
		sleep .5
		kill $GTKPIDSMP1
} #( end: fx(Sys_SMP)
##############################################################################
##############################################################################
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
echo 
MODE="`grep PUPMODE /etc/rc.d/PUPSTATE | cut -f 2 -d "="`" # from PUPSTATE
if [ "$MODE" = "12" ] || [ "$MODE" = "13" ]; then
    n=0
    lcMsgStr="grep PupMode in PUPSTATE is OK " && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
else
	#
	lcMsgStr="MODE is not FRUGAL mode '12' or '13' " && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
/usr/lib/gtkdialog/box_splash -bg yellow -fg red -border true  -close never -text "\
.     
.     ${lcMsgStr}
'                        "&
    RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!
	sleep 5
	kill ${GtkPid_Sbr_Box_Splash}
	#
    exit 1
fi # end: if if [ "$MODE" = "12" ] || [ "$MODE" = "13" ]
#
    CTB_StartUp     #(:  note: Must be First-Call !
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ -f ${CTB_FlgLockFile} ]  ; then
 
/usr/lib/gtkdialog/box_splash -fg yellow -bg red -border true  -close never -text "\
.
.     Found! ${CTB_FlgLockFile} : Soft-Lock !!!      
.       ... ---> Will Continue Running <---
. "&
	sleep 3
    RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!	# capture PID
	kill ${GtkPid_Sbr_Box_Splash} # after return
        #
		#
fi	# end: if  [ -f ${CTB_FlgLockFile} ] 
#
touch  "${CTB_FlgLockFile}" 
lcMsgStr="<<< end Lock-File code <<<" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
lcMsgStr="<<< " && Sys_Str2DevTrm "$lcMsgStr" "2" "3"
if [ ${gcCTBmode} = "B" ] ; then 	 	# "B"asic version 	
	lcSD_Flg_SD=" Scan "   		#(:  label <tool-tip>
	lcSD_Flg_HLP=" H "     		#(:  label <tool-tip> 
	lcSD_Flg_FAQ=" F "      	#(:  label <tool-tip> 
	lcSD_Flg_SRC=" S "   		#(:  label <tool-tip> 
	lcSD_Flg_UPL=" L "	   		#(:  label <tool-tip> 
	#
else 
	lcSD_Flg_SD=""
	lcSD_Flg_HLP=""
	lcSD_Flg_FAQ=""
	lcSD_Flg_SRC=""
	lcSD_Flg_UPL=""
	#
fi
#
lcBackUpStatus="---"  #(:  default preset gui display-status "Help/Source" string in gui
if [ ! -f "${CTB_BackUpStatus}" ]; then #(:  if backup not already run, then it has no flag up.
	export lcBackUpFocus="true"		#(:  gui control
	export lcQuitFocus="false"		#(:  gui control
    export lcBackUpStatus="Backup"  #(:  Normal "BackUp" First Run Label w/o flag
else
	export lcBackUpFocus="false"	#(:  gui control
	export lcQuitFocus="true"		#(:  gui control
    export lcBackUpStatus="Done"  	#(:  Has Been "Done" on Button message. 
    rm -f ${CTB_BackUpStatus} 		#(:  clear flag BackUpStatus display in gui.
fi
if [ -f "${CTB_FlgBugger_SD}" ]   ; then    #(:  Active SCAN process 
	n=0
    export lcBackUpStatus="${lcBackUpStatus}+Scan"  
fi
lcGuiColor3="green"
lcGuiColor2="blue"
lcGuiColor1="darkred"
lcGuiColor0=${lcGuiColor3}	# GUI display color for main title.
#
#gcSysDevId   Cold-Tar-Backup_to_save_DATA_
export CTB_Main_Gui\
='<window title="'${DISTRO_NAME}'...'CTB-SL'..." icon-name="gtk-convert" default_width="550" >
<vbox>
    <frame>
        <hbox>
			<hseparator width-request="1"></hseparator>
            <text editable="false" use-markup="true" xalign="0">
                <label> 
"<span  color='"'$lcGuiColor0'"'> <b>'Cold-Tar-Backup...v.${gcSysDevVer}' </b> </span>  <span color='"'$lcGuiColor3'"'><b>''</b></span><span color='"'$lcGuiColor2'"'>'${gcSysDevDob}'</span>" 
                </label>
            </text>
			<hseparator width-request="7"></hseparator>
			<button  tooltip-text="set Scan-All-Drives flag, xmessage"  label="'${lcSD_Flg_SD}'"
				has-focus="false">  <action>EXIT:"GuiSCN+"</action>  </button>
			<button  tooltip-text="Display Help-Notes, box_help" label="'${lcSD_Flg_HLP}'" 
				has-focus="false">  <action>EXIT:"GuiHLP+"</action>  </button>
			<button  tooltip-text="Display FAQ-notes, box_help" label="'${lcSD_Flg_FAQ}'" 
				has-focus="false">  <action>EXIT:"GuiFAQ+"</action>  </button>
			<button  tooltip-text="Display Source-Code, xmessage" label="'${lcSD_Flg_SRC}'" 
				has-focus="false">  <action>EXIT:"GuiSRC+"</action>  </button>
			<button  tooltip-text="Display Legal Notice" label="'${lcSD_Flg_UPL}'" 
				has-focus="false">  <action>EXIT:"GuiUPL+"</action>  </button>
			<button   tooltip-text="Nothing here "! label="  "  
				has-focus="false">  <action>lN:NothingHere</action>  </button>
			<hseparator width-request="3"></hseparator>
        </hbox>
    </frame>
    <frame>  
        <text editable="false" use-markup="true" >
            <label> "for Puppy Frugal Systems" </label>
        </text>
        <text editable="false" use-markup="true" >
            <label> "<b>Source: '${lcPupSaveNameSrc}' </b>" </label>
        </text>
        <text editable="false" use-markup="true" >
            <label> "<b>Target Subdir : '${gcCtbConfigTrgPrefix}' :</b>" </label>
        </text>
       <text height-request="36"  >
                <variable>'CTB_TrgDts'</variable>
                <input> 'CTB_TrgFilename' '\$CTB_PUPSAVE_PATH' </input>
        </text>
        <timer milliseconds="true" interval="'${CTB_REFRESH_INTERVAL}'" visible="false">
               <action>refresh:CTB_TrgDts</action>
        </timer>
        <hbox>   
            <text editable="false" >
                <label> "*'${lcPupRamObjMsg}'*                   "</label>
            </text>
        </hbox>
    </frame>
	<frame> 
		<hbox>
			<hseparator width-request="10"></hseparator>
			<text editable="false" use-markup="true" xalign="1">
				<label>"     " </label>  </text>
			<button label=" '${lcBackUpStatus}'  "  
				has-focus="'${lcBackUpFocus}'"
				tooltip-text="    ALWAYS read the <HELP> page and <FAQ> file ! " >
                <action>EXIT:"GuiBackUpCall+"</action>	 </button>
			<text editable="false" use-markup="true" xalign="1">
				<label>"     " </label>  </text>
			<button   has-focus="'${lcQuitFocus}'">
				<label> " 'Quit' " </label>
				<input file icon="gtk-no"></input>
				<action>EXIT:"GuiQuitCall+"</action>  </button>
			<text editable="false" use-markup="true" xalign="1">
				<label>"          " </label>  </text>
			<text editable="false" use-markup="true" xalign="0">
				<label>"                          " </label>  </text>
		</hbox>
    </frame>
</vbox>
</window>
'
#
#
if [ ${gcCTBmode} = "B" ]  ; then  
	eval "`gtkdialog --center -p CTB_Main_Gui`"     
else
	EXIT="GuiBackUpCall+"    #(:  Fall Thru to QUIT : CTU and CTA have NO GUI   
fi
#
###############################################################################################################
###############################################################################################################
function CTB_Fall_Thru() { # marker
    n=0
#!	 CTB: Fall-Thru to Sequential Test on If/Fi routines. 
#!	 CTB: Fall-Thru to Sequential Test on If/Fi routines. 
#!	 CTB: Fall-Thru to Sequential Test on If/Fi routines. 
} #( end: CTB_Fall-Thru
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiBackUpCall+" ] ; then
    n=0
	if [ "$lcBackUpStatus" = "Backup" ] ||  [ "$lcBackUpStatus" = "Backup+Scan" ] || [ "${gcCTBmode}" = "A" ] ; then  
		lcTarRetVal=0	#(:  default value before CTB_BackUpRun
		CTB_BackUpRun "${CTB_PUPSAVE_PATH} --- ${CTB_BACKUP_PATH}"	
		if [ ${gcCTBmode} = "B" ]   ; then 
			CTB_ReStart   
		else
			EXIT="QUIT"  #(:  will cause Fall-Thru Quit and NO ReStart 
		fi
	else
	    EXIT="QUIT"  #(:  Fall-Thru Quit and NO ReStart  
	fi
    EXIT="QUIT"  #(: setup Fall-Thru
	CTB_ClearFlgSys	
    rm -f ${CTB_BackUpStatus} 
fi # end: ft(EXIT:"GuiBackUpCall+")
### Now, Five User Option Buttons across the top of screen. 
###  Scan, Help, Faq, Source, Legal.
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiSCN+" ] ; then
    n=0 
	if [ ${gcCTBmode} = "B" ] ; then 	
		touch  ${CTB_FlgBugger_SD} 	#(:  mode "A" or "B" 
		lcDialogColor="  -fg blue -bg yellow  "
		lcMsgStr="---SCAN Auto Flag is Set for Extended Scanning BackUp ---"
		/usr/lib/gtkdialog/box_splash  $lcDialogColor -border true  -close never -text "$lcMsgStr" &
		GTKPIDerror=${!}
		sleep 3
		kill ${GTKPIDerror}
	fi
    CTB_ReStart  
fi # end: EXIT:"GuiSCN+"
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiHLP+" ] ; then
    n=0
    Sys_Box_HLP    
    CTB_ReStart	
fi # end: EXIT:"GuiHLP+"
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiFAQ+" ] ; then
    n=0
    Sys_Box_FAQ 
    CTB_ReStart	
fi # end: EXIT:"GuiFAQ+"
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiSRC+" ] ; then
    n=0
    Sys_Box_SRC 
    CTB_ReStart	
fi # end: ft(EXIT:"GuiSRC+")
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiUPL+" ] ; then
    n=0
    Sys_Box_UPL 
    CTB_ReStart	
fi # end: EXIT:"GuiUPL+"
#(! --------------------------------------------------------------------
if [ "$EXIT" = "GuiQuitCall+" ] || [ "$EXIT" = "QUIT" ]  || [ "$EXIT" = "X" ] ; then
	n=0
	CTB_ClearFlgSys	#(:  before actual fall-out to "exit 0"
    rm -f ${CTB_BackUpStatus} 
    lcMsgStr="..." && Sys_Str2DevTrm "${lcMsgStr}" "5" "7"
    lcMsgStr="... CTB : Terminal ReadMe :"  && Sys_Str2DevTrm "${lcMsgStr}" "2" "7"
    lcMsgStr="...   Tar has Created '.tar.gz' BackUp" && Sys_Str2DevTrm "${lcMsgStr}" "3" "7"
    lcMsgStr="...   Wait for USB devices to flush" && Sys_Str2DevTrm "${lcMsgStr}" "5" "7"
    lcMsgStr="..." && Sys_Str2DevTrm "${lcMsgStr}" "5" "7"
    lcMsgStr=">>>  Hit 'Enter' to clear Terminal <<< "
    Sys_Str2DevTrm "$lcMsgStr" "3" "7"
    Sys_Str2DevTrm "$lcMsgStr" "2" "7"
    Sys_Str2DevTrm "$lcMsgStr" "6" "7"
    lcMsgStr="...................................." && Sys_Str2DevTrm "${lcMsgStr}" "5" "7"
    lcMsgStr="<<< Quit Fall-Out <<<" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
    lcMsgStr="=== Will Show STACKED processes ===" && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
fi # end: EXIT:"QuitCall+"
#
exit 0
#
 
