#(: LIB-SBR.sh    SubRoutines 

# Routines to use as Standard througout system 


 
#(: ======================================================================
#(: fx(Sbr_SetVerDts)
#(: called by: Main ( )
#(: param: 
#(: purpose: 'gc' and 'Sys' System Standard Constants can be installed here.
#(: call this way:  Sys_SetVerDts
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note: 
#(:
#:######################################################################
function Sbr_SetVerDts() {  #: Active 

### Manual Entry for  Developers Version  Date-Time-Stamp is above in "header" 

# ln(dummy)={x["''"]}
n=0    #: common "stub" so bare funxtion() will not fault during test/dev. 

# OK to wait until PUPSTATE is mounted/loaded, then assign most values in funxtion(Sys_PupState) . 
gcSysDvar=`date`
gcSysDts="`date +%y%m%d-%H%M-%S`"   
	# Sys_SetVerDts
	# Note: grave-mark in date ( ) !!!

#(: ===============
#(: gcSysDtsNow 
#(: 		### Rationale: some Puppy OS default to GMT, we prefer Local time. 
#(: 		### This is Attempt to generate a "NOW" (this-moment) date-time constant.
#(: 		### Date : grave-mark in date () !!!
#(: 		###  Dts="`date +%y%m%d-%H%M-%S`"
#(: 		### adust from default "z" time 
#(: 		###		to local mid-america dts ( -5 hours ). 
#(:			###		Does not calc DayLightSavingsTime
#(:			###		But still a consistent error day-to-day. 
#(: 	lcNowDts=""
#(: 	lcNowDts="`date +%y%m%d%H%M-%S`"
#(: 	lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
#(: 	gcSysDtsNow="${lcNowDts}-local"
#(:
 
		lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
		gcSysDtsNow="${lcNowDts}-local"

gcSysDtsNow="${lcNowDts}"
		#
		# ## common location of all "My_Dev" executable Editing Source Code
gcSys_MyDev="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_"

	# log remains in /tmp for record until OS shutdown.
gcMntAllLogP="/tmp/Mgn_MntAllP.log "
gcMntAllLogU="/tmp/Mgn_MntAllU.log "

#	gcMntAllLogP="/tmp/Mgn_MntAllP.log "
#	gcMntAllLogU="/tmp/Mgn_MntAllU.log "
 

# ######################################################
#   "MGN_HEADER" related to DISTRO_SPECS and PUPSTATE
# ######################################################

	echo "   . "    # skip down start-up screen 
. /etc/rc.d/PUPSTATE    # gather basic "state" of Puppy "system" 
. /etc/DISTRO_SPECS    # gather basic Distro data

#: ## === Signature === main ============================
# rc.sysinit Header
# PUPSTATE already loaded
# DISTRO_SPECS already loaded
export gcSysDistroName="${DISTRO_NAME}"
export gcSysDistroVersion="${DISTRO_VERSION}" 
export gcSysDistroPuppySFS="${DISTRO_PUPPYSFS}"
export gcSysDistro_Db_Subname="$DISTRO_DB_SUBNAME"		
export gcSysKernPup="`uname -r`"
export gcSysKernName="Kern:`uname -r`"

### Alternate Menu Selection
# export gcMgnConfigArbIdd=""	done in fx(Sbr_ARB_init)	

# #######################################################################
#: ## === Signature for top-of-file === appears in terminal 

# begin: Signature splashed onto "start-up" screen. 
# Display system funxtions has not been setup yet.  
#      So, Must echo this way into terminal. 	
	lcMsgStr="...${0}......."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DobPrev:=${gcSysDevDobPrev}..." 
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DevDob:=${gcSysDevDob}...."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroName:=${DISTRO_NAME}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroVer:=${DISTRO_VERSION}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroDbSubname:=${DISTRO_DB_SUBNAME}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
# end: Signature 

} #
# end: fx(Sys_SetVerDts)
# ######################################################################







#(: ======================================================================
#(: fx(Sbr_Str2DevTrm)   #: A
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note :   
# ## 
# ## Str2DevTrm displays to "/dev/console"  as used by rc.sysinit and rc.shutdown 
# ##
# ## version for Geany BASH LxTerminal ( "Str2Trm" used by MGN.sh is embedded in MGN.sh )
# ##
    # ## called by Main ()
    # ## purpose: Standard Message-2-Terminal routine 
    # ##    designed for use from Geany Execute Terminal 
	# ##    does not display into /dev/console 
	# ##		unless ReDirect lcDevConsole=" > /dev/console" is enabled. 
    # ## param: "char string" "# color" "# margin"
    # ## purpose : generate system date/time constants.
    # ## rationale : One Time Manual Entry   for Geany "terminal" use.
    # ## note :
    # ##		bash can're-type' under some circumstances. 
# ##
# ## if using Geany "BASH terminal" for tracing, 
# ## then must use Sbr_Str2DevTrm() 
# ## which is done in MGN.sh, E3R.sh, S2F.sh, C3C.sh, CTB.sh, GTK.sh, et al .  
# ##
    # ## usage:
    # ##    Sbr_Str2DevTrm "string" "color" "margin"
    # ##    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    # ##    Sbr_Str2DevTrm "$lcMsgStr" "2" 15
    # ##    Sbr_Str2DevTrm "$lcMsgStr"  3  10
	# ##
    # ##  Shell script variables are not "typesafe,	
    # ##	BASH will 'type convert'  char vs number
    # ## example:
    # ##    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    # ##    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr"  2    3
	# ##
    # ## returns: action
	# ##
# ## alternative tests : param zero check and substitution:
# ## [ -z "${1}" ] && lcParStr="message"	# ## string
# ## [ -z "${2}" ] && lcParClr="5"  # ## color :  1,2,3,4,5   for  red,grn,yel,blu,pur
# ## [ -z "${3}" ] && lcParMrg="3"  # ## margin : 1,2,3,4,5  where mrg=5,10,15,20,25,30
# 
#:######################################################################
function Sbr_Str2DevTrm() {   #: ACTIVE
# ## capture all params
lcS2TStr=${1}   # ## STRING message 
lcS2TClr=${2}   # ## COLOR name or number
lcS2TMrg=${3}   # ## MARGIN number 1,5,10 ... 2,3,4,5,etc
# ## 
lcS2Topt=${4}	# ## "C"onsole "T"erminal
# 
lcDevConsole=""	# ## default to "T"erminal 
# 
# ## Sbr_Str2DevTrm	##########################################
# ##   Control ReDirect to "Console" or "Terminal" 
# ##   Normal default to "T"erminial 
# 
# ## ReDirect 
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;; 
   "T") lcDevConsole="" ;; 
    *)  lcDevConsole="" ;;	#: default "T"erminal mode
esac
# 
# ## Sbr_Str2DevTrm	##########################################
# ## if exist, then trap margin from param#3  as "number"|"char"   
# ## default left-margin=10 for Sbr_Str2DevTrm
# ## if ${lcDevConsole} ;; used for margin, then error = "ambigious redirect" 
# ## if margin, then use it.
# ## Margin: 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
# ## 
# ## Sbr_Str2DevTrm	##########################################
# ## trap color from param#2  "name"|"number"   ### default is "3" 

# ## Color: red, grn, yel, blu, pur, cyn, wht, wblu, wgrn, wgry
# ## if color, then use it. 
# ## Color:
case "${lcS2TClr}" in
    ""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;; #: default to yellow
    #~ red|"1") /bin/echo -n -e "\\033[1;31m"    >/dev/console ;;
    #~ grn|"2") /bin/echo -n -e "\\033[1;32m"    >/dev/console ;;
    #~ yel|"3") /bin/echo -n -e "\\033[1;33m"    >/dev/console ;; 
    #~ blu|"4") /bin/echo -n -e "\\033[1;34m"    >/dev/console ;;
    #~ pur|"5") /bin/echo -n -e "\\033[1;35m"    >/dev/console ;;
    #~ cyn|"6") /bin/echo -n -e "\\033[1;36m"    >/dev/console ;;
    #~ wht|"7") /bin/echo -n -e "\\033[1;37m"    >/dev/console ;;
    #~ wblu|"8") /bin/echo -n -e "\\033[4;7;30m"    >/dev/console ;; # ## blu   
    #~ wgrn|"9") /bin/echo -n -e "\\033[3;7;30m"    >/dev/console ;; # ## grn
    #~ wgry|"10") /bin/echo -n -e "\\033[5;7;30m"    >/dev/console ;; # ## gry
    *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; #: inject specific color nbr
esac
# ##
# ## Sbr_Str2DevTrm	###########################################
# ##   ${lcDevConsole}
	/bin/echo -n "$lcS2TStr"  ${lcDevConsole} 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
# ##
} #
# end: fx(Sbr_Str2DevTrm)




# #############################################################
# #############################################################
# #############################################################

#(: begin: CTB Sbr Box DATA Dump SubRoutines : copied

#(: ====================================================================
#(: fx(Sbr_Box_Message)	  # internal mod on gtkdialog box_help 
#(: called by : 
#(:    GuiHLP+  to  fx(Sys_Box_HLP)  to  Sbr_Box_Message
#(:    GuiFAQ+  to  fx(Sys_Box_FAQ)  to  Sbr_Box_Message
#(:
#(: receives param : Header$1 and loads '/tmp/box_help'
#(: purpose : custom Simple Message sbr 
#(:   based on gtkdialog box_help code processes.
#(: usage :
#(:   HEADING is a short "title bar" description. 
#(:   XML code is custom written to format "/tmp/box_help".
#(: returns: 
#(: method: 
#(:     gtkdialog --center -p XML-Format-file (which loads /tmp/box_help ) 
#(:
#(: note:
#(: purpose :  Simple Message sbr based on gtkdialog box_help
#(:   which allows author to change the "lead-in" XML code 
#(:   and thus change the "format" of this custom "message_box". 
#(:   Sbr_Box_Message does provide a "OK" user button. 
#(:   Sbr_Box_Message does provide a "markup" on text. 
#(:   Sbr_Box_Message does allow dimension changes. 
#(:   Sbr_Box_Message does not require a "URL" param.
#(: note:
#(:   XML assumes /tmp/box_help and "gtkdialog -p" internal code. 
#(:   XML sets up the markup and color options for the imported text. 
#(:   XML sets up the "OK" control button, and will show/close/"OK"
#(:
# 
#:######################################################################
function Sbr_Box_Message() {  #: ACTIVE   
# copied from CTB Active
# called by HLP and FAQ
# 
n=0
# 
export TEXTDOMAIN=libstardust
export OUTPUT_CHARSET=UTF-8
# 
# we are allowing a param for "HEADING"
if [ "$1" ] ; then
	Box_Msg_Heading="${1}"	
else
	Box_Msg_Heading="$(gettext '---Sbr_Box_Message---')"
fi
#
export Box_MessageXML='
<window title="'CTB$Box_Msg_Heading'" default-height="550" default-width="760">
<vbox space-expand="true" space-fill="true">
  <vbox space-expand="true" space-fill="true">
    <vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
      <vbox space-expand="false" space-fill="false">
        <text xpad="10" ypad="15" use-markup="true"><input file>'/tmp/box_help'</input></text>
      </vbox>
    </vbox>
  </vbox>
  <hbox space-expand="false" space-fill="false">
    <button>
      '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
      <label>'$(gettext 'Ok')'</label>
    </button>
  </hbox>
</vbox>
</window>'
 # 
 # same as eval "`gtkdialog --center -p Box_MessageXML`" 
gtkdialog --center -p Box_MessageXML	# assumes /tmp/box_help
#
# This gtk box sub-routine shows text via "gtkdialog box_help" code.
# This "gtkdialog -p" will read the default '/tmp/box_help' file via "XML" code block. 
# The XML code block sets up the markup and color options for the imported text. 
# (1) Markup/color are valid
# (2) Sets up the "OK" control button, and will show/close/"OK"
# 
} #
#  end: fx(Sbr_Box_Message)
#
# end: CTB Sbr Box DATA Dump SubRoutines
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# #######################################################################


#(: =========================================================
#(: fx(Sbr_Box_OK)	# internal
#(: called by : anyone, Bugger_Msg_OK
#(: purpose :  Simple OK sbr
#(: receives param : "Header", and "/tmp/box_help"
#(: returns : box_ok will close / clear 
#(: method: gtkdialog /tmp/box_help "box_ok"
#(: note: TOO much code . 
#(: note: maybe todo: embed "/usr/lib/gtkdialog/box_ok" 
#(:
#(: note: -------------------------------------------
#(:  BasePIDfile is "/tmp/box_help"
#(:  output storage file MUST BE "/tmp/box_help" 
#(:  due to hard-code in "/usr/lib/gtkdialog/box_help" 
#(:  Modifying would create a "dependency" problem for users. 
#
#:######################################################################
function Sbr_Box_OK() {  #: DEV MGN internal string 
# 
# GPL #Sigmund Berglund, dec 2013
#  
n=0
# 
# Must be compatible ? 
# gtkdialog box_OK "head" "icon name" "StringMsg" 
# Sbr_Box_OK       "head" "icon name" "StringMsg" 

# box_ok_gae
# MGN "HELP" display 
#~ case $1 in 
#~ ""|-h|--help)
	#~ echo 'This box shows one ok-button, one icon, and textstring(s)
#~ markup/span is valid

#~ Usage :
  #~ box_ok [--ok-label text] HEADING MSG-TYPE|ICON "textstring1" "textstring2" "..."

  #~ HEADING  : title text
  #~ MSG-TYPE : sets title/window icon
             #~ can be: complete, info, error or warning
  #~ ICON     : is a svg file. If path is not defined, /usr/share/pixmaps/puppy/ will be used

#~ Example:
  #~ box_ok "Title" info "read this message"
  #~ box_ok --ok-label "Close" "Title" complete "Finished processing.."
  #~ (3sec timeout): 
	#~ box_ok "heading" complete "text" &; XPID=$!; sleep 3; pkill -P $XPID

#~ # gtkdialog -v
#~ # gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
#~ # Built with support for: GTK+ 2, Glade.
#~ '
	#~ exit ;;
#~ -v )
#~ '
#~ # gtkdialog -v
#~ # gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
#~ # Built with support for: GTK+ 2, Glade.
#~ '
	#~ exit ;;
#~ esac

# ======================================================

export TEXTDOMAIN=libstardust
export OUTPUT_CHARSET=UTF-8

OK_LABEL=$(gettext 'Ok')
for i in $@ ; do
	case $i in
		--ok-label)
			OK_LABEL="$2"
			shift 2
			;;
	esac
done

HEADING="$1"	
# $1 is window title top bar 

# $2 is icon name 
case $2 in
	complete)
		ICON=/usr/share/pixmaps/puppy/dialog-complete.svg
		ICON_WM=gtk-yes
		FRAME="$(gettext 'Complete')"
		;;
	info)
		ICON=/usr/share/pixmaps/puppy/dialog-info.svg
		ICON_WM=gtk-info
		FRAME="$(gettext 'Info')"
		;;
	error)
		ICON=/usr/share/pixmaps/puppy/dialog-error.svg
		ICON_WM=gtk-no
		FRAME="$(gettext 'Error')"
		;;
	warning)
		ICON=/usr/share/pixmaps/puppy/dialog-warning.svg
		ICON_WM=gtk-warning
		FRAME="$(gettext 'Warning')"
		;;
	nb)
		ICON=/usr/share/pixmaps/puppy/nb.svg
		ICON_WM=gtk-no
		FRAME="$(gettext 'NB!')"
		;;
	*)
		ICON="$2"
		ICON_WM=gtk-about
		FRAME="$(gettext 'Unknown!')"
		;;
esac

# S is XML to format embedded parm#3 string
S='
<window title="'$HEADING'" icon-name="'$ICON_WM'" resizable="false">
 <vbox space-expand="false" space-fill="false">
     <hbox space-expand="true" space-fill="true">
      <vbox space-expand="true" space-fill="true">
          <vbox space-expand="true" space-fill="true">
           <text><label>" "</label></text>
          </vbox>
          <vbox space-expand="false" space-fill="false">
          <pixmap>
           <input file>'${ICON}'</input>
           <height>48</height>
           <width>48</width>
          </pixmap>
          </vbox>
         <vbox space-expand="true" space-fill="true">
           <text><label>" "</label></text>
         </vbox>
       </vbox>
         <vbox space-expand="false" space-fill="false">
           <text><label>" "</label></text>
         </vbox>
      <vbox>
		  <vbox space-expand="true" space-fill="true">
			 <text><label>" "</label></text>
		  </vbox>
		  <vbox space-expand="false">'
			[ "$3" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$3'"</label></text>'
			[ "$4" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$4'"</label></text>'
			[ "$5" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$5'"</label></text>'
			[ "$6" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$6'"</label></text>'
			[ "$7" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$7'"</label></text>'
			[ "$8" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$8'"</label></text>'
			[ "$9" ] && S=$S'<text xalign="0" use-markup="true"><label>"'$9'"</label></text>'
			[ "${10}" ] && S=$S'<text xalign="0" use-markup="true"><label>"'${10}'"</label></text>'
			[ "${11}" ] && S=$S'<text xalign="0" use-markup="true"><label>"'${11}'"</label></text>'
	S=$S'
		  </vbox>
		  <vbox space-expand="true" space-fill="true">
			 <text><label>" "</label></text>
		  </vbox>
      </vbox>
    </hbox>
    <hbox space-expand="false" space-fill="false">
      <button>
         '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
         <label>" '${OK_LABEL}' "</label>
       </button>
    </hbox>
 </vbox>
</window>'

export box_ok_string="$S"

gtkdialog --center -p box_ok_string
# 
} #
# end: fx{Sbr_Box_OK}



#(:======================================================================
#(: fx(Sbr_Box_Ok_Msg)	# internal
#(: called by : Bugger_Box_Ok_Msg
#(: purpose :  Simple Message sbr based on gtkdialog box_help
#(: receives param : parm1header,  gtkdialog -p box_ok requires file "/tmp/box_help"
#(: requires : "/tmp/box_help"
#(: method: gtkdialog XML-calls-/tmp/box_help
#(: returns : 
#(: note:
#(:   This custom box_ok_msg shows text in /tmp/box_help format
#(:   markup/span is valid
#
#(: note: --------------------------------------------------------------
#(:  BasePIDfile is "/tmp/box_help"
#(:  output storage file MUST BE "/tmp/box_help" 
#(:  due to hard-code in "/usr/lib/gtkdialog/box_help" 
#(:  Modifying would create a "dependency" problem for users. 
#
#:######################################################################
function Sbr_Box_Ok_Msg() {  #: DEV MGN internal gtkdialog
# 
lncDummy=0
# 
# HEADING is a short description. Maybe the app-name of the sender.
# URL is a link to a html-page (local or web), or a clean text file.
# ICON is a svg file. If path is not defined, /usr/share/pixmaps/puppy/ will be used
# 
# Sigmund Berglund, dec 2013
# GPL

#~ if [ -f /usr/bin/xmessage ] ; then 
	#~ n=0
#~ else
	#~ read
	#~ return
#~ fi

export TEXTDOMAIN=libstardust
export OUTPUT_CHARSET=UTF-8

# ICON=help.svg
# ICON_WM=gtk-help

lcBoxMsgHeading=${1}

				# MGN "HELP" display, not used in CTB
				#~ case ${lcBoxMsgHeading}  in ""|-h|--help)
					#~ echo '
				#~ This routine shows one box_help and textstring(s) and one ok-button. 
				#~ markup/span is valid

				#~ Usage :
				  #~ Sbr_Box_Ok_Msg [--ok-label text] HEADING  "textstring1" "textstring2" "..."

				  #~ HEADING  : title text
				  #~ MESSAGE  : string text, with embedded markup.

				#~ Example:
				  #~ box_hlpok "Title" "read this message"
				  #~ box_ok --ok-label "Close" "Title" complete "Finished processing.."
				  #~ (3sec timeout): '  > /tmp/box_help
					#~ ;;
				#~ -v|--version)
					#~ echo '
				#~ # gtkdialog -v
				#~ # gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
				#~ # Built with support for: GTK+ 2, Glade :'   > /tmp/box_help
					#~ ;;
				#~ esac
				
if [ "${lcBoxMsgHeading}" ] ; then
	lcDummy=0
	# param $1 is the "Heading" 
else
	# inject a known string.
	lcBoxMsgHeading="$(gettext '---MGN-Sbr_Box_Ok_Msg--- HELP ---gtkdialog')"	 
fi

				# Head and Icon control 

				#~ # begin: from box_help =======
				#~ # icon not used. 
				#~ if [ "`grep "svg$" <<< "$2"`" ]; then
					#~ ICON="$2"
				#~ elif [ "`grep "svg$" <<< "$3"`" ]; then
					#~ ICON="$3"
				#~ elif [ "$2" ]; then
					#~ XML_URL=''
				#~ # URL not used.
					#~ <vbox space-expand="false" space-fill="false">
					#~ <hbox border-width="10" space-expand="true" space-fill="true">
					  #~ <text space-expand="true" space-fill="true"><label>""</label></text>
					  #~ <eventbox space-expand="false" space-fill="false">
						#~ <text use-markup="true" space-expand="false" space-fill="false">
						  #~ <variable>URL</variable>
						  #~ <label>"<b><u><span color='"'#004BDD'"'>'$(gettext 'Further reading')'</span></u></b>"</label>
						#~ </text>
						#~ <action signal="enter-notify-event">disable:URL</action>
						#~ <action signal="leave-notify-event">enable:URL</action>
					   #~ <action signal="button-release-event">defaulthtmlviewer '$2'</action>
					  #~ </eventbox>
					#~ </hbox>
					#~ </vbox>'
				#~ fi
				#~ #
				# Icon not used .
				#~ if [ "`grep -F 'info.svg' <<< "$ICON"`" ]; then
					#~ ICON_WM=gtk-file
					#~ HEADING="$(gettext 'Info') - $1"
				#~ fi
				#~ #
				#~ # Date not used 
					#~ # MGN_dts=$( date +'%a_%d_%b__%Y_%M_%d...%H:%m:%S' )	# spcl
					#~ # MGN_dts=$( date +'%a_%d_%b__%Y_%M_%d' )
				#~ #
				#~ # end: from box_help =======

# Sbr_Box_Ok_Msg


# if "HEAD" then requires "/tmp/box_help"
lcBoxMsgFileName="/tmp/box_help"
        #true:  <text xpad="10" ypad="15" use-markup="true"><"${lcBoxMsgDts}"></text>
		# xpad=pixels for left margin 

# ${lcBoxMsgXMLtxt}
export lcBoxMsgXMLtxt='
<window title="'${lcBoxMsgHeading}'" default-height="450"  default-width="750" space-expand="true" border-width="2"  resizable="true" >
<vbox space-expand="true" space-fill="true">
  <vbox space-expand="true" space-fill="true">
    <vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
      <vbox space-expand="false" space-fill="false">
        <text xpad="25" ypad="15" use-markup="true"><input file>'${lcBoxMsgFileName}'</input></text>
      </vbox>
    </vbox>
  </vbox>
  <hbox space-expand="false" space-fill="false">
    <button>
      '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
      <label>'$(gettext 'Ok')'</label>
    </button>
  </hbox>
</vbox>
</window>'

gtkdialog --center -p lcBoxMsgXMLtxt

# gtkdialog will show/close/"OK"clear , will assume /tmp/box_help file. 
# 
} #
# end: fx(Sbr_Box_Ok_Msg)




#(:======================================================================
#(: fx(Sbr_Box_Splash)	# internal
#(: called by : tested by Bugger_BoxSplash
#(: call method: Sbr_Box_Splash text fg bg 
#(: purpose :  Simple Splash calling "gtkdialog/box_splash"
#(: receives param : text string, color, color 
#(: returns : with pid to kill
#(: method: gtkdialog box_splash req string
#(: note: todo: embed code for "/usr/lib/gtkdialog/box_splash" 
#(: note: 
#(:  BasePIDfile is "/tmp/box_help"
#(:  output storage file MUST BE "/tmp/box_help" 
#(:  due to hard-code in "/usr/lib/gtkdialog/box_help" 
#(:  Modifying would create a "dependency" problem for users. 
#
#:######################################################################
function Sbr_Box_Splash() {  #: DEV MGN internal
# 
n=0
# 
# call with:  parm1 text, + parm2 (fg) , + parm2 (bg) 
# Sbr_Box_Splash "< Sbr Box Splash >" "white" "purple" 
# useful parm 
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg ${2} -bg ${3} -close never -text "\
.     Sbr_Box_Splash
.     ${1}
.                        "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!	
	#~ kill ${GtkPid_Sbr_Box_Splash} # after return
    # 
# 
} #
# end: fx(Sbr_Box_Splash)



#(:======================================================================
#(: fx(Sbr_Box_Test)	#: N
#(: called by : anyone
#(: purpose :  Test
#(: receives param : none
#(: returns : 
#(: note: 
#: 
#:######################################################################
function Sbr_Box_Test() {  #: NOT MGN internal

n=0

# gae work
					#~ #(: 
					#~ #(: *** begin : SPLASH: tar < ERROR > ***
					#~ lcMsgStr=" Tar < ERROR > file not found" && Sys_Str2DevTrm "$lcMsgStr" "red" "3"
					#~ lcDialogColor="  -fg yellow -bg red  "
					#~ /usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text "$lcMsgStr" &
					#~ GTKPIDerror=${!}
					#~ sleep 5
					#~ kill ${GTKPIDerror}
					#~ echo "==========> kill $GTKPIDerror ---"
					#~ #(:    end : SPLASH: ERROR **************

		#~ # gae work
		#~ #(: *** begin : SPLASH: tar < DONE > ***
		#~ lcMsgStr=" Tar < DONE > " && Sys_Str2DevTrm "$lcMsgStr" "red" "3"
		#~ lcDialogColor="  -fg yellow -bg red  "
		#~ #(:  position dependent on left margin 
		#~ /usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text " 
			 #~ $lcMsgStr :$lcMsgTos:     
										   #~ " &
		#~ GTKPIDdone=${!}
		#~ sleep 5
		#~ kill "${GTKPIDdone}"
		#~ #(:    end : SPLASH: DONE **************


		#~ lcMsgStr="MODE is not FRUGAL '12' or '13' " && Sys_Str2DevTrm "$lcMsgStr" "pur" "3"

		#~ #-----------------------------------------------------------------------
		#~ /usr/lib/gtkdialog/box_splash -bg yellow -fg blue -close never -text "\
		#~ .     
		#~ .     ${lcMsgStr}
		#~ '                        "&
		#~ #------------------------------------------------------------------------
		#~ RETVAL=$?
		#~ GtkPid_Sbr_Box_Splash=$!	
		#~ sleep 5	
		#~ kill ${GtkPid_Sbr_Box_Splash}

	#~ #-----------------------------------------------------------------------
	#~ /usr/lib/gtkdialog/box_splash -bg yellow -fg blue -close never -text "\
	#~ .     
	#~ .     ${lcMsgStr}
	#~ '                        "&
	#~ #------------------------------------------------------------------------
    #~ RETVAL=$?
	#~ GtkPid_Sbr_Box_Splash=$!	
	#~ sleep 3	
	#~ kill ${GtkPid_Sbr_Box_Splash}

#--------------------------------------------------------------
#(:  BasePIDfile is "/tmp/box_help"
#(:  output storage file MUST BE "/tmp/box_help" 
#(:  due to hard-code in "/usr/lib/gtkdialog/box_help" 
#(:  Modifying would create a "dependency" problem for users. 
#--------------------------------------------------------------
# 
} #
# end: fx(Sbr_Box_Test)







         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'blue'"'>Pupsave '${type}' to backup</span>"</label>
         </text>





    export gcPHBzeroRun="$0" ### >>>  before any "cd -"  outside of GEANY <<<
    echo "export:$gcPHBzeroRun:'0':"
    
    echo "config:${gcPHBconfig}:" 
    echo "build config: echo '0' into :${gcPHBconfig}:" 

    echo "${gcPHBzeroRun}" > ${gcPHBconfig}

    #~ whereis rc.z_PHB-dev.sh${gcPHBzeroRun} > ${gcPHBconfig} # is /root/my-applications/bin/rc.z_PHB-dev.sh

	gcConfigSrcFn="`cat ${gcPHBconfig}`"
    echo "cat:${gcConfigSrcFn}:"

read

                echo "===:${gcConfigSrcFn}:======================"
                echo "===:${gcPHBzeroRun}:====================== ReStart ==="
                echo ":${0}:" 
            cd /root
                echo ":${0}:" 
                echo ":${gcPHBzeroRun}:" 
                echo "===:${gcPHBzeroRun}:====================== ReStart ==="
    #~ read    
 
    ${gcConfigSrcFn}
 
##############################################################
##############################################################
##############################################################




#########################################################################


