#!/bin/sh
#
### rc.z_GTK-sampler.sh
#
### rc.z_GTK-sampler for testing gtk_dialog and other gtk routines.
### .sh format so GEANY sees a 'script' executable.
# 
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: System Developer Initial DOB 
lcSysInitDobParm="220315-0900"		

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: System Developer ID name of this Linux BASH script
lcSysDevId="GTK"	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#

#############################################################

#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx()
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:

##########################################################




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_SetVerDts() {
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_SetVerDts)
#(: called by: Main 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:


### Transfer Dev Data into Global MGN var. 
export gcSysInitDob="${lcSysInitDobParm}"	# Dev Entry 	
export gcSysDevId="${lcSysDevId}"			# Dev Entry

### MGN will be used in 8 Linux OS, so this info must be floating. 
### export gcSysDistroVerID="UpupFF" #+d_20.12"		### always manual edit per iso


# Linux BASH command "cut" help 
# 	PUPSAVE has these:
# 	PUPSFS='sda1,ext4,/pup_UpupFF-sda/puppy_upupff+d_20.12.sfs'
# 	PUPSAVE='sda1,ext4,/pup_UpupFF-sda/upupff+dsave-D08-sda-D'
# f = field,  N = Numbered field, -d is delimiter 
# so, -f N -d "/" 
# cut -f 3 -d "/" 
# cut field #3 out to delimiter 

###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcGtkDob=${gcSysInitDob}	###  from top of script, Not Used. 
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

### must wait until PUPSTATE is mounted/loaded, then assign values. 
## export gcSysDistroLoc="SDA1" ### from PUPSTATE PDEV1
## export gcSysDistroId="UpupFF"	### 

		### MGN does not call rc.zStr2Sig 
export gcSysDts="`date +%y%m%d-%H%M-%S`"   ### Sys_SetVerDts
		### Note: grave-mark in date ( ) !!!

		### Rationale: some Puppy OS default to GMT, we prefer Local 
		### Attempt to generate a "NOW" this moment date-time constant.
		### Date : grave-mark in date () !!!
		###  Dts="`date +%y%m%d-%H%M-%S`"
		### adust from default "z" time 
		###   to local mid-america dts ( -5 hours ).
		lcSysNowDts=""
		lcSysNowDts="`date +%y%m%d%H%M-%S`"
		lcSysNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
		gcSysNowDts="${lcNowDts}-local"
export gcSysNowDts="${lcNowDts}"
		###
		### now:  have exported "gcMgnDob" and"gcSysDts" and "gcNowDts" 
 		### touch DTS Marker file
        lcFileDtsOut="/0-GTK_DTS"		
        touch  "${lcFileDtsOut}"       ### this is a Zero-Byte DTS Marker file .
		### echo "${gcNowDts}" >> "${lcFileDtsOut}"
		#
		###
}   # end: fx(Sys_SetVerDts)
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




##############################################################


#~ #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ function GTK_Splash_RunningAlready() {   # Not Used
#~ #
    #~ /usr/lib/gtkdialog/box_ok "ERROR" -text "GTK_Splash_RunningAlready
    #~ ... GTK_Splash_RunningAlready
    #~ ... (1) Must Quit GTK program
    #~ ... (2) Must Clear Running GTK window
    #~ ... (3) Must Re-Start GTK program"
    #~ #
    #~ return 1
    #~ #
#~ }   # end: fx(GTK_Splash_RunningAlready)


### === Signature = standard =====================================
echo ". " >/dev/console
lcMsgStr="${0}: ${gcSysInitDOB} :${1}:"
/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;33m $lcMsgStr \\033[1;36m***\\033[0;39m" > /dev/console  
### end: Signature ===============================================


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: format of header copied from  MGN and rc.zStr2DevTrm  
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#
function Sys_Str2DevTrm() {   ### active
#
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_Str2DevTrm)
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:

### 
### Str2DevTrm displays to "/dev/console"  as used by rc.sysinit and rc.shutdown 
###
### version for Geany BASH LxTerminal ( "Str2Trm" used by MGN.sh is embedded in MGN.sh )
###

    ### called by Main ( )
    ### purpose: Standard Message-2-Terminal routine 
    ###    designed for use from Geany Execute Terminal 
	###    does not display into /dev/console 
	###		unless lcDevConsole=" > /dev/console" is enabled. 
    ### param
    ### purpose : generate system date/time constants.
    ### rationale : One Time Manual Entry   for Geany "terminal" use.
    ### note :
    ###		bash can're-type' under some circumstances. 

###
### if using Geany "BASH terminal" for tracing, 
### then must use Sys_Str2DevTrm() 
### which is done in MGN.sh, B2R.sh, S2F.sh, C3C.sh, CTB.sh, et al .  
###
    ### usage:
    ###    Sys_Str2DevTrm "string" "color" "margin"
    ###    Sys_Str2DevTrm "$lcMsgStr" "2" "3"
    ###    Sys_Str2DevTrm "$lcMsgStr" "2" 15
    ###    Sys_Str2DevTrm "$lcMsgStr"  3  10
	###
    ###  Shell script variables are not "typesafe,	
	###	BASH may 'type convert'  char vs number
    ### example:
    ###    lcMsgStr="xxx" && Sys_Str2DevTrm "$lcMsgStr" "2" "3"
    ###    lcMsgStr="xxx" && Sys_Str2DevTrm "$lcMsgStr"  2    3
	###
    ### returns: action
	###
		
### dev param zero check and substitution:
### [ -z "${1}" ] && lcParStr="message"	### string
### [ -z "${2}" ] && lcParClr="5"	### color : 1,2,3,4,5   or  red,grn,yel,blu,pur
### [ -z "${3}" ] && lcParMrg="3" ### margin : 1,2,3,4,5 where mrg=5,10,15,20,25,30

### capture all params
lcS2TStr=${1}    ### STRING message 
lcS2TClr=${2}    ### COLOR name or number
lcS2TMrg=${3}  ### MARGIN number 1,5,10 ... 2,3,4,5,etc
### 
lcS2Topt=${4}	### "C"onsole "T"erminal
#
lcDevConsole=""	### default to "T"erminal 
#
###    does not display into /dev/console 
###		unless lcDevConsole=" > /dev/console" is enabled. 
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;; 	### Dev "C"onsole mode
   "T") lcDevConsole="" ;; 	### default Geany "T"erminal mode
    *)  lcDevConsole="" ;;
esac
#
### note: BASH will "Re-Type" var sometimes. 
#
### MGN_rc.zStr2Trm	##########################################
### trap margin from param#3  as "number"|"char"   
### default left-margin=10 ###
### if ${lcDevConsole} ;; used for margin, then error = "ambigious redirect" 
#### Margin 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
### 
### MGN_rc.zStr2Trm	##########################################
### trap color from param#2  "name"|"number"   ### default is "3" 
### Color: red, grn, yel, blu, pur, cyn, wht, wblu, wgrn, wgry
case "${lcS2TClr}" in
    #~ "1") /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;;
    #~ "2") /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;;
    #~ "3") /bin/echo -n -e "\\033[1;${lcS2TClr}m"    ${lcDevConsole} ;; 
    red|"1") /bin/echo -n -e "\\033[1;31m"   ${lcDevConsole} ;;
    grn|"2") /bin/echo -n -e "\\033[1;32m"   ${lcDevConsole} ;;
    yel|"3") /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;; 
    blu|"4") /bin/echo -n -e "\\033[1;34m"   ${lcDevConsole} ;;
    pur|"5") /bin/echo -n -e "\\033[1;35m"   ${lcDevConsole} ;;
    cyn|"6") /bin/echo -n -e "\\033[1;36m"   ${lcDevConsole} ;;
    wht|"7") /bin/echo -n -e "\\033[1;37m"   ${lcDevConsole} ;;
    wblu|"8") /bin/echo -n -e "\\033[4;7;30m"   ${lcDevConsole} ;; ### blu   
    wgrn|"9") /bin/echo -n -e "\\033[3;7;30m"   ${lcDevConsole} ;; ### grn
    wgry|"10") /bin/echo -n -e "\\033[5;7;30m"   ${lcDevConsole} ;; ### gry
    *)  /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;; ### default = yel
    #~ ""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
    #~ *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; ### default = yel
esac
###
### MGN_rc.zStr2Trm	###########################################
###   ${lcDevConsole}
	/bin/echo -n "$lcS2TStr"  ${lcDevConsole} 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
###
} # end: fx(Sys_Str2DevTrm)









#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_ShowSplash() {     ### not active ### gtkdialog box_splash
	### Not Working Yet ###
    ### FOUR param.  param(msg) must be "$var"

### capture all params
lcPar1r=${1}	
lcPar2r=${2}	
lcPar3r=${3}	    
lcPar4r=${4}	    

    ### 200401-0500 ### Not Working Yet ###
    ### written / working OK ### rc.z_B2T
    ### Sys_ShowSplash "${lcMsgStr}"  "green" "red" gtk-ok && sleep 2 && kill ${GTKPIDX}
	/usr/lib/gtkdialog/box_splash -fg ${2} -bg ${3} -close never -icon ${4} -text "${1}"
    GTKPIDX=$!
    RETURN ${GTKPIDX}
}   ### end Sys_ShowSplash



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_Seek_Box_Dialog() {    #(:  active
#
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_Seek_Box)
#(: called by : Main_GUI, small button 
#(: purpose :  Seek Target Subdir in GTK box.
#(: receives param : none
#(: returns : focus to Main GUI.
#(: note:
#(:  	gtkdialog/box_help will handle format and embedded color text codes. 
#(:  	xmessage will NOT handle format and color embedded text codes.
#
lnn=0
#
### Test_Main_9001_Dialog.sh
lcMsgStr=">>> SEEK_SUBDIR_DIALOG >>>" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"

export SEEK_SUBDIR_DIALOG='
 <vbox>

  <hbox>
		<button>
		  <label>Label</label>
		  <action>echo action: You pressed the button with the label.</action>
		</button>
		<button>
		  <input file>fileopen.xpm</input>
		  <action>echo action: You pressed the button with the pixmap.</action>
		</button>
  </hbox>

	<hbox>
		<button yes>
		  <action>echo action: You pressed the Yes button.</action>
		</button>
		<button no>
		  <action>echo action: You pressed the No button.</action>
		</button>
	</hbox>

	<hbox>
		<button ok>
		  <action>echo action: You pressed the OK button.</action>
		</button>
		<button help>
		  <action>echo action: You pressed the Help button.</action>
		</button>
	</hbox>

	<hbox>
	   <button cancel></button>
	</hbox>

	</vbox>

</vbox>

'

gtkdialog --program=SEEK_SUBDIR_DIALOG

lcMsgStr="<<< SEEK_SUBDIR_DIALOG <<<" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"
#~ sleep 1

#~ --print-ir
#(:  end: fx(Sys_Seek_Box_Dialog)
} #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_PupState() {
    ###
    ### called by Main ( )
    ### param
    ### purpose :
    ###     consolidation of PUPSTATE
    ###     control generation of local var
    ### rationale :
    ### Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###
    ### maintain gcVerDts
    #~ lcVerDtsTmp="${gcVerDts}"
    lcVerDtsTmp="${gcSysInitDob}"
    #--- load PUPSTATE --- from only location : "/etc/rc.d/"
    . /etc/rc.d/PUPSTATE
    ### restore gcVerDts
    gcVerDts="${lcVerDtsTmp}"
    #
	echo "BK ==============================================="  
	lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	lcSaveFileNameBase="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameBase = ${lcSaveFileNameBase}"
	echo "BK ==============================================="  
	#
    ### direct import, similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupDts="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
#
### maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSve}"  # savefilename from PUPSTATE
    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # savefilename
    lcPupSaveNameDts="${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`"     ### grave-mark in date() !!!
    lcPupSaveNameTrg="${lcPupSaveNameDts}.tar.gz"
    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcPupSubDir="${lcPsubDir}.BKP-`date +%y%m%d-%H%M-%S`"      ### grave-mark in date() !!!

###

### SIGNATURE ###############################################
### SIGNATURE ###############################################
### SIGNATURE ###############################################
lcGTKdistro="UpupFF" ### Developers OS Version.
lcGTKname="GTK"
lcGTKdts="${gcVerDts}"
lcSleep="sleep 1"
#############################################################

### Determine the 'location' of script files
### Sys_PupState    lcReStartCall   ### OK
    ### filenames must be parsed,
    ### tested for location of running script.
    ### Preferred location is "/etc/rc.d/"
    ### Editing location is "/mnt/home/MY_/usr-share/gae_Dev/"


### Determine the 'location' of script files
### Sys_PupState    lcReStartCall   ### OK
    #~ if [ -f PUPSTATE ] ; then
        #~ echo "lcGuiTitle = /etc/rc.d/rc.z_MGN ... MGN_PupState ..."
        #~ lcGuiTitle="MGN_/etc/rc.d"
    #~ else
        #~ echo "lcGuiTitle = /gae_Dev_/Edit_MGN/rc.z_MGN ... MGN_PupState ..."
        #~ lcGuiTitle="MGN_Dev/Edit"
    #~ fi

### Determine the 'location' of script files
### Sys_PupState    lcReStartCall   ### OK
    #~ if [ -f PUPSTATE ] ; then
        #~ echo "lcReStartCall = /etc/rc.d/rc.z_MGN ...... MGN_PupState ..."
        #~ lcReStartCall=". /etc/rc.d/rc.z_MGN"
    #~ else
        #~ echo "lcReStartCall = /gae_Dev_/Edit_MGN/rc.z_MGN ...... MGN_PupState ..."
        #~ lcReStartCall=". /initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_MGN/rc.z_MGN"
    #~ fi

### 'export' Marks each NAME for automatic export to the environment
### of subsequently executed commands.
### If VALUE is supplied, assign VALUE before exporting.

    #~ export lcPupDts
    #~ export lcPupHome lcPupSave  lcPupMode
    #~ export lcPupSaveNameRaw lcPupSaveName lcPupSaveNameDts
    #~ export lcPupSaveNameTrg lcPupSaveNameSrc lcPsubDir
export GTK_ReStart

    #
}   ### Sys_PupState



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function Sys_Src_Box() {    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
    ###
    ### called by : Main_GUI, small button 
    ### receives param : none
    ### purpose :  direct link from Main_GUI , returns to same.
        echo ">>> begin Sys_Src_Box >>>"
        lcSourceTxt="/tmp/B2T_source.txt"
    cat $0 > ${lcSourceTxt}     ### $ ZERO ### deposits copy of source code
    xmessage -bg LemonChiffon1 -borderless -center -file ${lcSourceTxt} -wrap
        pidx=$!
        kill $pidx
        rm -f ${lcSourceTxt} ### removes tmp copy of source code
        echo "<<< end Sys_Src_Box <<<"
    ###
    ### Note on 'xmessage' method 
    ### when 
    ###     modeled as the "Help" method, embedded in 'button' .
    ###     <button label="" has-focus="false">  <action>Sys_Src_Box</action>  </button>
    ### then 
    ###     "xmessage" dialog window opens, does not find contents. 
    ### however
    ###    "/usr/lib/gtkdialog/box_help" works for "Help"
    #
    #
} ### end: Sys_Src_Box




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function GTK_Help_Box() {
#
#(: fx( GTK_Help_Box )
#
#(: system gtkdialog "box_help" location is  '/usr/lib/gtkdialog/box_help'
#

### gcVerDts is declared/assigned at beginning (top) of program
### function GTK_SetVerDate is called at top of '=== M A I N ( ) ==='

#~ GTK_ShowSplash ".1:char " "red" "green" 'gtk-ok'

        #~ GTKPID=$!
        #~ sleep 7
        #~ kill ${GTKPID}


### code from B2T ###
### echo this out, then call it.
	echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "======"</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"  GTK-sampler FAQ "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "===========" </span></span>

<b>calls Tar.gz for fast backup</b>
<b><span foreground='"'green'"'>"Puppy GTK-sampler"</span></b>

<span foreground='"'red'"'>"  "  v: ${gcVerDts}"  "</span> "  glene77is"


<span foreground='"'blue'"'>"Authors note about 'GTK' BASH coding :"</span>
GTK code is a <span background='"'white'"' foreground='"'red'"'>"simplified code "</span>
GTK code is a <span background='"'white'"' foreground='"'green'"'>"readable code "</span>
GTK code is a <span background='"'white'"' foreground='"'green'"'>"modifiable code "</span>

###########################
 Note abt 'GTK_help_box':
 ... If Error in Help Page,
 then Help Page may fail.
###########################

<span background='"'black'"' foreground='"'white'"'>"'Further Reading'"</span> links to Murga-Linux
under Murga's "\'FileSystem\'" topic
which contains our "\'current-version.zip\'"
and user notes.




Caution:
If you have multiple Linux OS mounted,
then the wrong one may become live !
Check your OS systems for specific names.
Use unique subdir names for OS systems.

<span foreground='"'red'"'>"Note on running executable BASH script :"</span>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.





<span foreground='"'red'"'>"ROX Debug Method :"</span>
Use the ROX 'Run in Terminal' to Execute a script.
<span foreground='"'red'"'>"Geany Debug Method :"</span>
Use the Geany Execute function
   to run the script 'BASH-Terminal'
All 'echo' commands will display.

<span foreground='"'blue'"'>"About : "</span> <span foreground='"'green'"'>"GTK"</span>
<span foreground='"'green'"'>"GTK is a very Simple Program ! "</span>
<span foreground='"'green'"'>"GTK has No Bells / No Whistles ! "</span>
<span foreground='"'green'"'>"GTK has No Hidden Options ! "</span>
<span foreground='"'green'"'>"GTK is easy to Read / Modify ! "</span>
............................................................."\
> /tmp/box_help
/usr/lib/gtkdialog/box_help  "Pup GTK Help !!!" \
"http://murga-linux.com/puppy/viewtopic.php?p=1050224"

}   ### end GTK_Help_Box
### code from B2T ###

### last lines: first param is title,
### last lines: second param is "Further Reading" URL .
### function 'name' must be the 'called name'
###
#############################################################
#############################################################
#############################################################




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function GTK_cleanup() {
    ###
#(: fx(GTK_cleanup)
    ### called by : Error_Restart, top of Main, Check-After-Main-GUI .
    ### param :
    ### purpose:  remove any written tmp file
    ###     #~ touch "$MGN_lockfile" /tmp/MGN-lockfile


	rm -rf "$GTK_lockfile"  ### this is "B2T_cleanup"

    ### kill any lingering $pid displays ### lock file
	#~ busybox ps | grep 'B2T_PUPSAVE_B2T_BKP' | grep -v grep | awk '{print $1}' | \
	#~ while read pid ; do kill $pid ; done
    echo "GTK_cleanup : 'DONE'"
    #~ exit 0
    ### gaurantee an absolute "quit".
}   ### GTK_cleanup
#---



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GTK_Locate_Src() {  ### Not Used 
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: begin: fx(GTK_Locate_Src)    
	###
	#(: name: fx(GTK_Locate_Src)    
	#(: called by: GTK_restart
    #(: purpose: Determine the 'location' of script files
    #(:   instead of passing param /path/filename
    #(:   simply set a flag via 'RETVAL'.
    #(:   No Param Required.
	#(:
    #
    ### example call:
    ### MGN_Locate_Src
    ### assign RETVAT like this:
    ###    RETVAL=0 && return $RETVAL
    ### read RETVAL like this:
    ### [ $RETVAL -eq 1 ] && lcReStartCall="/etc/rc.d/rc.z_MGN"
    ### [ $RETVAL -ne 0 ] && lcReStartCall="/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_MGN/rc.z_MGN"
    #

    if [ -f PUPSTATE ] ; then   ### this 'root' location is final /etc/rc.d/  location
        RETVAL=1
        return ${RETVAL}        ### "PUPSTATE" is "local"  in "/etc/rc.d/"
    else
        RETVAL=0
        return ${RETVAL}        ### else use "PUPSTATE" is "foreign" 
								### in "/mnt/home/MY_/usr-share/My_Dev_"
    fi

return  $RETVAL
} #(: end: fx(GTK_Locate_Src)



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function GTK_ReStart() {
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ### called by : GTK, other selections, but not 'QUIT'
    ### param :
    ### purpose :
    ### send :

    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"
    lcMsgStr=">>> GTK_ReStart $0 >>>" && Sys_Str2DevTrm "$lcMsgStr" "pur" "4"
    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"

    echo "cleanup : 'Start'"
    echo "Remove $MGN_lockfile ..."
	rm -rf "$GTK_lockfile"  ### this is "GTK_lockfile"

    echo "Remove lingering PID splash ..."  ### ? 
	busybox ps | grep 'GTK_' | grep -v grep | awk '{print $1}' | \
	while read pid ; do kill $pid ; done

	#~ sleep 3
    #--------------------------------------------------
	#(: call to: fx(GTK_Locate_Src) 	# Not Used 
	#(: from: GTK_ReStart
	#(: purpose: standardized to "/mnt/home/MY_/usr-share/My_Dev_" 
	#(:    "/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_GTK/rc.z_GTK.sh"
	#(:	GTK_Locate_Src  ### Locate where MGN is located
	#(:  if [ $RETVAL -eq 1 ]; then
	#(:   lcReStartCall="/etc/rc.d/rc.z_GTK.sh"
	#(:  else
	#(:   lcReStartCall="/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_GTK/rc.z_GTK.sh"
	#(:  fi
	#(: 
    #--------------------------------------------------
    
    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"
    lcMsgStr="<<< GTK_ReStart $0 <<<" && Sys_Str2DevTrm "$lcMsgStr" "pur" "4"
    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"

    sleep .5
    
    #---------------------------------------------------------
        $0      ### $ ZERO  ### will restart this program ###
    #---------------------------------------------------------
    
    echo ""
    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"
    lcMsgStr="> > > Exit < < < Calls are Stacked ... " && Sys_Str2DevTrm "$lcMsgStr" "pur" "4"
    lcMsgStr="-----------------------------------------------XXX" && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"
    echo ""

} # end: fx(GTK_ReStart)
#-----------------------




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function GTK_MBrequired() {   # Not Used 
    ###
	#(: name: fx(GTK_MBrequired)
    #(: called by : Main_GUI
    #(: param(1) $GTK_PUPSAVE_PATH
    #(: purpose : build n echo "free disk required"
    #(: sends : GTK_PUPSAVE_PATH as echo into Main-GUI
	#(:
    #
	a=$(du -c -m -s "$1")   ### -c = --total, -m = --block-size=1m, -s = --summarize
	read -r aa bb <<< "$a"
	echo -n "Free disk required at least: $aa  MB"	### for GUI-Display
    ###
} #(: end: fx(GTK_MBrequired)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function GTK_Bkpfilename() {	# Not Used 
    ###
	#(: name: fx(GTK_Bkpfilename)
    #(: called by: Main_GUI
    #(: param (1)
    #(: purpose : echo PUPSAVE_NAME to GUI
    #(: 
	echo -n "Backup DTS : ${B2T_PUPSAVE_NAME}.BKP-`date +%y%m%d-%H%M-%S`.tmp"  ### grave-mark in date() !!!
    ### special for GUI-Display

    ### made a compact date, gae
    ### remember to use grave-mark "`" in "date" function parameters.
    ### grave-mark is with the tilde "~" key, top row, left end.

} #(: end: fx(GTK_Bkpfilename)



#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function B2T_compression_dialog() {	# Not Used 
#
#(: name fx(B2T_compression_dialog)
#(: called by : B2T_Backup
#(: param:
#(: purpose: example of calling 'tar'
#(: purpose: declare & assign Options for "tar"
#(: sends: 
#(:
#(: options: for "tar" :
#(:   -W error
#(:   -R show block number with each message
#(:   -z gzip
#(:   -checkpoint=1000 , display marker numbers every checkpoint
#(: 
lnn=0
                #~ TAROPT="-z "
                #~ TAROPT="-z --checkpoint=1000 refresh=100"
                #~ TAROPT="-z --checkpoint-action='echo > /tar.txt"

            ### Trace will show every 1000 tar operations, in "BASH Execute Terminal"
			#~ TAROPT="-z --checkpoint=1000"

			#~ TAREXT='tar.gz'

} #(: end: fx(B2T_compression_dialog)

 





### to do :
### Begin changing varname+data to standard 'readable' format.
### Some var data come from PUPSTATE.
### Some var data come from original code.
### We are merging varnames and vardata into standard "readable' format.
#
### maintain similarity to PUPSTATE "name"
#
### 'export' Marks each NAME for automatic export
### to the environment of subsequently executed commands.
### If VALUE is supplied, assign VALUE before exporting.
### see Main () for example.
###





            #~ ############################################################

            #~ echo "begin tar >>>>>>>>>>>>>>>>>>."
            #~ ###------------------------------------------------------------
            #~ tar -c ${TAROPT} -f ${lcPupSaveNameTrg} ${lcPupSaveNameSrc}/
            #~ ###------------------------------------------------------------
            #~ echo "end  tar <<<<<<<<<<<<<<<<<<<<."

			#~ RETVAL=$?
            #~ ### This is After 'tar' :

            #~ ############################################################


### all function () moved to top of code ### all function () moved to top of code
### all function () moved to top of code ### all function () moved to top of code
### all function () moved to top of code ### all function () moved to top of code





#**********************************************************************#

#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
#

#***********************************************************************
#(: name: fx(GTK_Main) 
#(: purpose: Fall-Thru to this code as "first line" 

Sys_SetVerDts   # >>> # fetch Developer's Version DateTimeStamp

Sys_PupState	# >>> # fetch Puppy OS system State Vars 

#(: Define LockFile 
GTK_lockfile="/tmp/GTK-lockfile"    ### Main for Lock-File
GTK_lockval='0' ### Main for Lock-File
#
#(: Export: 
export -f GTK_Help_Box     
export -f Sys_Src_Box     

###^^^^^^^^^^^^^^^^^^


#~ export lcB2Tdistro lcB2Tname lcB2Tdts lcB2TSleep


### Marks each NAME for automatic export to the environment
### of subsequently executed commands.
### If VALUE is supplied, assign VALUE before exporting.
#~ export -f B2T_cleanup      ### this is Main()

### code from original appears to have no function in Backup prg.
### this info is displayed in the "terminal" .
### Perhaps this is a leftover debug from the original.
###     trap  B2T_cleanup SIGHUP SIGINT SIGTERM
### option -l -p will list 'SIG' names and signals into terminal window.
### see 'trap --help' for information.



#(: process: Main Execution

### Geany : Execute-in-Terminial "Trace" works OK 

#(: req: Vital re-assignment of data into 'lcSaveFolder' !!!
    lcSaveFolder="`echo $lcPupSave | cut -f 3 -d ","`"   ### /savefilename
#(: req: temp assignment into old var
#(:   change from old 'lcSF' to new 'lcSaveFolder' 
    lcSF="`echo $lcPupSave | cut -f 3 -d ","`"           ### /xxx/savefilename

#(: 
#(: peculiar bug from original Back-2-Tar: now under control :
#(: On Error, was been falling back to original /usr/sbin/   !!!!!!!!!!!!!!!
#(: IF : we are warning only to run on 32bit Frugal save-FOLDER, else failure,
#(: THEN : we do not need to check nor warn-n-exit here !
#(: THEREFORE : this litle block was culled.
#(: lcSF is lcPupSave via "cut -f 3 -d "  above
#(:    if [ ! "$SF" ] ; then   ### gae, then this is a "full install" and B2T will not handle it.
#(:      /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Currently using a full partition..."
#(:      B2T_cleanup
#(:      exit
#(:    fi
#(: 
################################


### Marks each NAME for automatic export to the environment
### If VALUE is supplied, assign VALUE before exporting.

    ### default to these original values .
	#~ export SAVEFOLDER=1
	export REFRESH_INTERVAL=1000 #1 seconds

    ### gae, in original appears that B2T_PUPSAVE_PATH is forced to be default in DISPLAY ?
    #~ export B2T_PUPSAVE_PATH="/mnt/home${lcSaveFolder}"

    ### gae, in original appears that B2T_LOCDEFAULT is forced to be default in DISPLAY ?
    #~ export B2T_LOCDEFAULT="/mnt/home${PSUBDIR}"

    #~ export B2T_PUPSAVE_NAME="${SF##*/}"
    ### ${SF##*/} = basename $SF
    ### culled #~ export B2T_BACKUP_PATH=$(B2T_validate_BACKUP_location)

    #~ export -f B2T_compression_dialog  B2T_MBrequired  B2T_Bkpfilename  B2T_Backup
    ### culled #~ B2T_validate_BACKUP_location ERROR_RESTART

    ### from PUPSTATE
    ###~ B2T_BACKUP_PATH="${lcPupSaveNameSrc}"   ### line 1014 Not Required
    ### ?     export -f B2T_BACKUP_PATH
    ### needs conversion.

###^^^ MAIN() ^^^^^^^
#(: prg continues into Main-GUI

### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
### MAIN GUI #####################################################################
#

    ### gae, outline of Main_GUI elements
    ###
    ###  Main GUI
    ### outline
    ###     "window"
    ###     "vbox"
    ###         "frame" ("label")
    ###         "frame" ("text1" "text2" "BKPFILE" "timer")
    ###     "hbox" (button 1,2,3 )
    ###



########################################################################
########################################################################
########################################################################

###----- begin --- GTK Main GUI -------
###----- begin --- GTK Main GUI -------
###----- begin --- GTK Main GUI -------


         #~ <timer milliseconds="true" interval="'${REFRESH_INTERVAL}'" visible="false">
           #~ <action>refresh:TEXT1</action>
           #~ <action>refresh:TEXT2</action>
           #~ <action>refresh:BKPFILE</action>
                #~ <action>refresh:lcPupSaveNameTrg</action>
         #~ </timer>

     #~ <frame  Note: GTK test for GTKdialog code  >

           #~ <button label="" has-focus="false">
                #~ <action>lcDummy:0</action>
            #~ </button>

### export Marks each NAME for automatic export to the environment
### of subsequently executed commands.
### If VALUE is supplied, assign VALUE before exporting.
###
#~ export B2T_PUPSAVE='
#~ <window title=". 'Back-2-Tar'  "icon-name="gtk-convert" default_width="500">
#~ export -f lcGuiMgn="       "

### GTK_Main_Gui ########################################################
### GTK_Main_Gui ########################################################
### GTK_Main_Gui ########################################################

### MainGui

export GTK_Main_Gui='
<window title=". 'G-T-K_sampler_gui'  "icon-name="gtk-convert" default_width="550">

   <vbox>

      <frame>
        <text editable="false" use-markup="true" xalign=".001">
        <label>
"<span color='"'green'"'> 'G-T-K-sampler' </span> <span color='"'red'"'> v:'${gcVerDts}.' </span> <span color='"'blue'"'> 'G-T-K---' </span>  "
        </label>
        </text>
      </frame>



    <hbox>

		 <button label=""   has-focus="false">  <action>lcDummy:0</action> </button>

         <button label="'BoxSeekDialog==='" has-focus="false"> <action>lcDummy:0</action> </button>

		 <button label="'BSD'" has-focus="false">
			<action>EXIT:BSD</action>
		 </button>

         <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>
	</hbox>


    <hbox>

		 <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
         <button label="'BoxSplash==='" has-focus="false"> <action>lcDummy:0</action> </button>

		 <button label="'BS01'" has-focus="false">
			<action>EXIT:BS01</action>
		 </button>
		 <button label="'BS04'" has-focus="false">
			<action>EXIT:BS04</action>
		 </button>
		 <button label="'BS05'" has-focus="false">
			<action>EXIT:BS05</action>
		 </button>
		 <button label="'CASE01'" has-focus="false">
			<action>EXIT:CASE01</action>
		 </button>
		 <button label="'cDialog'" has-focus="false">
			<action>EXIT:CDIALOG</action>
		 </button>

                   <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>

	  </hbox>



	  <hbox>

		 <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CHECK-BOX==='" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_YN_H_4'" has-focus="false">
			<action>EXIT:CBYNH4</action>
		 </button>
			<button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_YN_V_4'" has-focus="false">
			<action>EXIT:CBYNV4</action>
		 </button>
            <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_YN2'" has-focus="false">
			<action>EXIT:CBYN2</action>
		 </button>
            <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_YN3'" has-focus="false">
			<action>EXIT:CBYN3</action>
		 </button>
            <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_YN4'" has-focus="false">
			<action>EXIT:CBYN4</action>
		 </button>
            <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'CB_OK1'" has-focus="false">
			<action>EXIT:CBOK1</action>
		 </button>
            <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>
	  </hbox>

	  <hbox>
			<button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'EDIT-BOX==='" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'Edit_Box-1'" has-focus="false">
			<action>EXIT:EB01</action>
		 </button>
                    <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'Edit_Box_2_x'" has-focus="false">
			<action>EXIT:EB02</action>
		 </button>
                    <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'Help_Box'" has-focus="false">
			<action>EXIT:HB01</action>
		 </button>
                    <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
		 <button label="'PlayBell'" has-focus="false">
			<action>EXIT:PB01</action>
		 </button>
                   <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>
	  </hbox>



        <hbox>
                    <button label="" has-focus="false"> <action>lcDummy:0</action> </button>
			<button label="'General==='" has-focus="false"> <action>lcDummy:0</action> </button>

             <button label="'About+'" has-focus="false">
                <action>EXIT:'ABOUT+'</action>
             </button>
             <button label="'Icon'" has-focus="false">
                <action>EXIT:'ICON+'</action>
             </button>
             <button label="'Help+'" has-focus="false">
                <action>EXIT:'HELP+'=</action>
             </button>
             <button label="'FAQ+'" has-focus="false">
                <action>EXIT:'FAQ+'</action>
             </button>
             <button label="'Source+'" has-focus="false">
                <action>EXIT:'SRC+'</action>

             </button>
                   <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>
        </hbox>

        <hbox>
                    <button label="" has-focus="false">
                        <action>lcDummy:0</action>
                     </button>

		 <button use-stock="true" label="'GTK-QUIT'" has-focus="true">
			<action>EXIT:'QUIT'</action>
		 </button>

                   <button label="       " has-focus="false"> <action>lcDummy:0</action> </button>
	  </hbox>



   </vbox>

</window>
'
###----- GTK_Main_Gui test -------

### eval GUI with parameters :
eval "`gtkdialog --center -p GTK_Main_Gui`"
### eval GUI with parameters :


         #~ <button label="" has-focus="false"> <action>lcDummy:0</action> </button>

		 #~ <button label="'String'" has-focus="false">
			#~ <action>EXIT:STRING</action>
		 #~ </button>


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:



### End of GTK_Main_Gui ####################################################
### End of GTK_Main_Gui ####################################################
### End of GTK_Main_Gui ####################################################










### these are Triggered via Fall-Thru Method ###########################
### these are Triggered via Fall-Thru Method ###########################
### these are Triggered via Fall-Thru Method ###########################






#######  Help #########################################################
#######  Help #########################################################
#######  Help #########################################################

########################################################################
### EXIT:'HELP+' ###
echo "----Help-------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'HELP+')
#(: if( HELP+ )
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'HELP+'</action>
#(:			if [ "$EXIT" = "HELP+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "Help=" ] ||  [ "$EXIT" = "HELP=" ] ; then

    echo ">>> Help="
    ### call local function GTK_help_box
    ### this local call will NOT ReStart
    GTK_Help_Box
    #
    echo "<<< Help="
    #
    GTK_ReStart
    #
fi
### end of "Help" block


########################################################################
### EXIT:FAQ+"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'FAQ+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'FAQ+'</action>
#(:			if [ "$EXIT" = "FAQ+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "FAQ+" ] ; then

    ### call local function GTK_faz_box
    ### this local call will NOT ReStart
    GTK_FAQ_Box
    #
    echo "<<< GTK_FAQ_Box"
    #
    GTK_ReStart
    #
fi
### end of "FAQ+" block
########################################################################





########################################################################
#~ echo "Source Display Message Window---------------------XXX"
### "EXIT:SRC+"
### purpose: Display Source Code in message window. 

#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'SRC+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'SRC+'</action>
#(:			if [ "$EXIT" = "SRC+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "SRC+" ] ; then

    n=0

    lcMsgStr=">>> SRC+ " && Sys_Str2DevTrm "$lcMsgStr" "red" "3"
    lcMsgStr="   Will 'stack' pid calls if repeated.  " && Sys_Str2DevTrm "$lcMsgStr" "grn" "3"

    Sys_Src_Box    ### local function name

    lcMsgStr="<<< SRC+ " && Sys_Str2DevTrm "$lcMsgStr" "red" "3"

    ### will RESTART script auto ### via MGN ReStart method .
    GTK_ReStart

fi
### end EXIT:SRC+






#######  String  #########################################################
### EXIT:String ###

echo "----String-------------------------------------------XXX"

#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'STRING+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'STRING+'</action>
#(:			if [ "$EXIT" = "STRING+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "String" ] || [ "$EXIT" = "STRING" ] ; then

    echo
    echo "--- TEST-01 String---"  ### "Testing Routines in Geany 'Execute' terminal ------"
    echo "Declare / Assign a long string"
    stringZ="abcABC123ABCZabc" #   0123456789..... # 0-based indexing.
    echo "stringZ=${stringZ}"
    # above string is in buffer
    echo "======================================================"

    ### testing code

    #~ # Echoes second and following positional parameters.
    echo -n "{stringZ:2} :"
    echo ${stringZ:2}
    echo
    echo -n "{stringZ:2:3} :"
    echo ${stringZ:2:3} # Echoes three positional parameters, starting at second.
    echo
    # should be Same as above.
    echo -n "{stringZ:2} :"
    echo ${stringZ:2}
    echo

    echo " stringZ uses base 0 pointer :"
    echo

    echo -n "{stringZ:0} : "   # abcABC123ABCabc
    echo ${stringZ:0}   # abcABC123ABCabc

    echo -n "{stringZ:1} : "   # bcABC123ABCabc
    echo ${stringZ:1}   # bcABC123ABCabc

    echo -n "{stringZ:7} : "   # 23ABCabc
    echo ${stringZ:7}   # 23ABCabc

    echo -n "{stringZ:7:3} : " # 23A
    echo ${stringZ:7:3} # 23A

    Z=9 ### string from 7 thru 9
    echo -n "{stringZ:7:Z} : "  #  must be numerical position
    echo ${stringZ:7:Z}         #  must be numerical position

        #---------------------------------------------------------------
    ### testing code

           #~ lcMsgStr="B2T TEST === /gtkdialog/box_splash "

           #~ B2T_show_splash_g_ly "\
        #~ ...  ${lcMsgStr}
            #~ ...   DONE !  ...
	#~ ...................................................."
                #~ RETVAL=$?
                #~ YAFPIDTEST=$!
                #~ sleep 3
                #~ kill ${YAFPIDTEST}
                #~ echo "==========> kill ${YAFPIDTEST} ---OK---"

        #---------------------------------------------------------------
    ### testing code

           #~ B2T_show_splash_b_ly "\
        #~ ...  ${lcMsgStr}
                 #~ .
	     #~ ...   Without 'kill'
                        #~ this will linger forever !  ...
	     #~ ...   Wait 3 sec and
                       #~ 'kill' will clear and exit !  ...
        #~ ...................................................."
                #~ RETVAL=$?
                #~ YAFPIDTEST=$!
                #~ sleep 3
                #~ kill ${YAFPIDTEST}
                #~ echo "==========> kill ${YAFPIDTEST} ---OK---"

#
### "YAF" is prior development to gtkdialog/box_splash
### so change over to GTKdialog
#
### possible param/options
### "$PROG" -text "$msg" -deco 'Temp-yas' -placement 'center' -close 'never' -align 'left'
### -bg_gradient_height '80' -icon 'gtk-ok' -icon_width '-1' -font 'DejaVu Sans Bold ' -fontsize '10' -fg '#186df1' -bg '#edf710' -margin_width '10' -margin_height '10' -timeout '3' -bg_gradient true -border true -wrap true -ontop false -styled false -transparent false
### -placement middle

    ### testing code

    ### echo ${stringZ:7:*} # runaway # seeks to end of file , error.

    ### testing code

    # Three characters of substring.
    ##~ stringZ=abcABC123ABCabc
    ##~ echo ${#stringZ}
    ##~ echo `expr length $stringZ`
    ##~ echo `expr "$stringZ" : '.*'`
    ##~ stringZ=abcABC123ABCabc123abc123abc
    ##~ echo `expr match "$stringZ" 'abc[A-Z]*.2'`
    ##~ echo `expr match "$stringZ" 'abc[a-z]*.2'`
    ##~ echo `expr "$stringZ" : 'abc[A-Z]*.2'`
    #~ echo

    #~ exit 0
    ### fall out, will show 'error' exit .

    ### testing code
        #~ if B2T_MBavailable "$B2T_BACKUP_PATH" ; then
            #~ if B2T_Backup "$B2T_PUPSAVE_PATH" "$B2T_BACKUP_PATH" ; then
                #~ B2T_cleanup
                #~ exit 0 #success ### leave program .
            #~ fi
        #~ fi
		#~ if B2T_Backup "$B2T_PUPSAVE_PATH" "$B2T_BACKUP_PATH" ; then
			#~ cleanup
			#~ exit 0 #success
		#~ fi
        ### from PUPSTATE
        ### B2T_BACKUP_PATH=${lcPupSaveNameSrc}
        ### lcPupSaveNameSrc=${lcPupSaveNameTrg##*/}
        ### $(B2T_validate_BACKUP_location)

        #~ echo "tar -c ${TAROPT} -f ${lcPupSaveNameTrg} ${lcPupSaveNameSrc}/"
        #~ echo "tar PSN Trg : ${lcPupSaveNameTrg}"
        #~ echo "tar PSN Src : ${lcPupSaveNameSrc}"

        #~ echo
        #~ echo "*** Execute-in-Terminal ******************************"
        #~ echo "Exe PSN    : ${lcPupSaveName}"
        #~ echo "Exe PSND   : ${lcPupSaveNameDts}"
        #~ echo "Exe PSNTrg : ${lcPupSaveNameTrg}"
        #~ echo "Exe PSNSrc : ${lcPupSaveNameSrc}"
        #~ echo "to SEEK: ${lcFindFile} :  "
        ### echo "SEEK: /upupbbsave-BB19+17-0102.BKP-200212-1513-49.tar.gz"
        ### echo "SEEK: /initrd/mnt/dev_save/pup_UpupBB+17-Lex128/upupbbsave-BB19+17-0102.BKP-200212-1513-49.tar.gz"
        #~ echo "*** Execute-in-Terminal ******************************"
        #~ echo
        ###
    #
    GTK_ReStart
    #
fi
### end of "String" block



################################################################################
#######  Sys_Box_Seek_Dialog ###################################################
###  

### EXIT:BSD
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:BSD)
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:BSD</action>
#(:		  if [ "$EXIT" = "BSD" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
echo "----BSD--------------------------------------------XXX"
if [ "$EXIT" = "BSD" ] ; then
### (D)
n=0
lcMsgStr="<<< Box_Seek_Dialog >>>" && Sys_Str2DevTrm "$lcMsgStr" "7" "3"

#~ /usr/lib/gtkdialog/box_splash -fontsize 11  -margin 10  -fg green -bg yellow -icon gtk-ok -close never -text ".\ xxx

/usr/lib/gtkdialog/box_ok "ERROR" -text "GTK_BSD_Running
.
.
.
.         Box-OK for Seek_Dialog 
.
.         $lcFileName
.
.          " 

    pidx=$!
    #~ kill ${pidx}
	GTKPID0DX=${!}

    #~ sleep 3
   kill ${GTKPID0DX}

	GTK_ReStart

fi # end: ft(Box_Seek_Dialog)





################################################################################
#######  Box_Splash 01 #########################################################



### EXIT:BS01 ### Box_Splash
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
echo "----BS01--------------------------------------------XXX"
if [ "$EXIT" = "BS01" ] ; then
### (D)

/usr/lib/gtkdialog/box_splash -fontsize 3  -margin 10  -fg green -bg yellow -icon gtk-ok -close never -text ".\
.
.
.
.         Box_Splash
.
.         $lcFileName DONE 0A:
.
.          " &

    sleep 1
    pidx=$!
    #~ kill ${pidx}
	GTKPID0DX=${!}
    kill ${GTKPID0DX}

 	/usr/lib/gtkdialog/box_splash -fontsize 5 -margin 5   -fg green -bg yellow -icon gtk-ok -close never -text ".\
.
.
.
.         Box_Splash
.
.         $lcFileName DONE 0B:
.
.          " &

    sleep 1
    pidx=$!
    #~ kill ${pidx}
	GTKPID0DX=${!}
    kill ${GTKPID0DX}

/usr/lib/gtkdialog/box_splash -fontsize 7 -margin 3   -fg green -bg yellow -icon gtk-ok -close never -text ".\
.
.
.
.         Box_Splash
.
.         $lcFileName DONE 0C:
.
.          " &

    sleep 1
    pidx=$!
    #~ kill ${pidx}
	GTKPID0DX=${!}
    kill ${GTKPID0DX}

/usr/lib/gtkdialog/box_splash  -fontsize 11  -margin 1  -fg green -bg yellow -icon gtk-ok  -close never -text ".\
.
.
.
.         Box_Splash
.
.         $lcFileName DONE 0D:
.
.          " &

    sleep 1
    pidx={$}!
    #~ kill ${pidx}
	GTKPID0DX=${!}
    kill ${GTKPID0DX}

/usr/lib/gtkdialog/box_splash -fontsize 11 -fg green -bg yellow -icon gtk-ok  -close never -text ".\
.
.
.
.         Box_Splash   and wait 5
.         -fontsize 11  -margin 1
.         $lcFileName DONE 0E:
.
.          " &

    sleep 5
    pidx=$!
    #~ kill ${pidx}
	GTKPID0DX=${!}
    kill ${GTKPID0DX}

    #
	GTK_ReStart
    #

fi
### end of "BS01" block
#----------------------




########################################################################
#######  Box_Splash 04 #################################################

### EXIT:BS04 ### Box_Splash
echo "----BS04---------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "BS04" ] ; then

    sleep 1
 	/usr/lib/gtkdialog/box_splash -fg orange -bg blue -close never -text "\
            $lcFileName DONE 02:      " &

    sleep 1
	GTKPID0D2=$!

    sleep 1
 	/usr/lib/gtkdialog/box_splash -fg yellow -bg dred -close never -text "\
            $lcFileName DONE 03:      " &

    sleep 1
	GTKPID0D3=$!


    #~ sleep 2
    #~ kill ${GTKPID0D1}
    sleep 1
    kill ${GTKPID0D2}
    sleep 1
    kill ${GTKPID0D3}
    sleep 1
    kill ${GTKPID0D4}
    echo "==========> kill ${GTKPID0D} ---Done ---"

sleep 1

    #
    GTK_ReStart
    #

fi
### end of "BS04" block
#----------------------


########################################################################
#######  Box_Splash 05 #################################################

### EXIT:BS05 ### Box_Splash
echo "----BS05--------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "BS05" ] ; then

/usr/lib/gtkdialog/box_splash -fg white -bg red -close never -text "\
 >>> ERROR <<< " &

                #~ RETVAL=$?
                GTKPID=$!
                sleep 3
                kill $GTKPID
                echo "==========> kill GTKPID "




    /usr/lib/gtkdialog/box_splash  -fb green -bg yellow  -close never  -text "\
           ... TEST-01 box splash  200303-1028 ...
                       ..."  &
                RETVAL=$?
                GTKPID=$!
                sleep 3
                kill $GTKPID
                echo "==========> kill GTKPID "



    lcFileName="GTKdilog/box_splash"

    /usr/lib/gtkdialog/box_splash  -fb green -bg yellow  -close never  -text "\
    $lcFileName
     ...   Test-01  NOW !  ...
     " &

                #~ RETVAL=$?
                GTKPID=$!
                sleep 3
                kill $GTKPID
                echo "==========> kill GTKPID "

	#~ /usr/lib/gtkdialog/box_splash -fb green -bg yellow  -margin_width '33' -font 'DejaVu Sans Bold ' -fontsize '10'   -close never  -icon 'gtk-ok'  -text "\
    #~ M2R : $lcFileName : v:$lcFileVerDts
     #~ ...   Running  NOW !  ...
     #~ " &
                #~ RETVAL=$?
                #~ YAFPIDTEST=$!
                #~ sleep 3
                #~ kill ${YAFPIDTEST}
                #~ echo "==========> kill ${YAFPIDTEST} ---OK---"


	#~ /usr/lib/gtkdialog/box_ok "Test GTKdialog/box_ok " error "$@"


    #
    GTK_ReStart
    #



fi
### end of "BS" block
########################################################################



########################################################################
#######  Case 01  ######################################################

### EXIT:CASE01 ### Case
echo "----CASE01-------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CASE01" ] ; then

case $PUPMODE in
     0)
        echo "0"
        ;;
     2)
        echo "2"
        ;;
     4)
        echo "4"
        ;;
     6)
        echo "6"
        ;;
     8)
        echo "8"
        ;;
     13)
        echo "==================="
        echo "case $PUPMODE in 13"
        echo "==================="
        sleep 3
        ;;
     *)
        echo "case $PUPMODE in otherwise "
        echo "*) OTHERWISE "
        sleep 3
        ;;
    esac

    #
    GTK_ReStart
    #

fi
### end of "CASE01" block
#----------------------




########################################################################
#######  cDialog #######################################################

### EXIT:CDIALOG ### CDIALOG
echo "----CDIALOG-------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CDIALOG+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CDIALOG+'</action>
#(:		  if [ "$EXIT" = "CDIALOG+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CDIALOG" ] ; then
### (D)

### ShutDown Code for fx("ASKTOSAVE")
### cDialog

   #~ dialog --timeout 3 \
   #~ --yes-label "$(gettext 'SAVE')" \
   #~ --no-label "$(gettext ' NO SAVE ')" \
   #~ --yesno "$(gettext 'ENTER key to Select')" 7 30
   #~ >/dev/console

### This one is OK, but problem with documentaton , on every turn.
   #~ dialog --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "$(gettext 'Press ENTER key to save session... 
#~ wait 6 seconds to NO SAVE')" 0 0 >/dev/console 

   dialog --timeout 6 --yes-label "$(gettext 'SAVE')" --no-label "$(gettext 'NO SAVE')" --yesno "$(gettext 'Press ENTER key to save session... 
      wait 6 seconds to NO SAVE')      " 0 0 

   #~ dialog   --title "Ask2Save" --timeout 7 \
   #~ --yes-label "$(gettext 'SAVE')" \
   #~ --no-label "$(gettext ' NO SAVE ')" \
   #~ --yesno "$(gettext 'Press ENTER key to Activate ...')" \
#~ 7 35

   RETVAL=$?

    echo "========================================================"
    [ $RETVAL -ne 0 ] && echo "$(gettext "Session not saved") <<<<<<<"
    [ $RETVAL -eq 0 ] && echo "$(gettext "Saved OK") >>>>>>>"
    echo "========================================================"

  if [ $RETVAL -eq 0 ]; then 
    #~ echo "$(printf "$(gettext 'Saving session to %s (%s)...')" "${SAVEFILE}" "${SAVEPART}")" >/dev/console

########################################################################
### === Signature ==================================================
	lcMsgStr="Saving Session ... "
	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" # > /dev/console  
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;32m $lcMsgStr \\033[1;36m***\\033[0;39m" # > /dev/console  
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" # > /dev/console  
	sleep .1
### end: Signature =================================================

    #~ /usr/sbin/snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw

  else

    #~ echo "NOT SAVING  session ..." >/dev/console

########################################################################
### === Signature ==================================================
	lcMsgStr="NOT Saving ... "
	/bin/echo -e "\\033[10G\\033[1;35m*** \\033[1;31m $lcMsgStr \\033[1;35m***\\033[0;39m" # > /dev/console  
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;36m*** \\033[1;32m $lcMsgStr \\033[1;36m***\\033[0;39m" # > /dev/console  
	sleep .1
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" # > /dev/console  
	sleep .1
### end: Signature =================================================

  fi 

	/bin/echo -e "\\033[16G\\033[1;37m*** \\033[1;33m GTK \\033[1;37m***\\033[0;39m" # > /dev/console 
	/bin/echo -e "\\033[16G\\033[1;37m*** \\033[1;33m GTK \\033[1;37m***\\033[0;39m" # > /dev/console 
	/bin/echo -e "\\033[16G\\033[1;37m*** \\033[1;33m GTK \\033[1;37m***\\033[0;39m" # > /dev/console 

###
sleep 1
#~ return $RETVAL   ### 'return' only from subroutine () {xxxxxxx}
    #
### H / W

    GTK_ReStart
    #

fi
### end of "CDIALOG" block
#-----------------------------------------------------------





#################################################################################
### {{{}}} working ### use CheckBox(4) plus 'OK' to expand the MGN menu options.
### Check Box for (1) C3C (2) M2R (3) S2F (4) B2T   and   Apply()
#################################################################################


######## CB_YN-H-4 #######################################################

### EXIT:CBYNH4 ### Check_Box
echo "---- CBYNH4 -----------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYNH4" ] ; then

   n=0
    echo "gtkdialog --center -p GTK_CB_CBYNH4"
    #~ sleep 1

    #(: . /tmp/parameters.tmp    ### previous var values or touch file
	#(: this little function requires dox

    GTK_Apply() {
    echo "CBH1=$CBH1" >  /tmp/parameters.tmp
    echo "CBH2=$CBH2" >> /tmp/parameters.tmp
    echo "CBH3=$CBH3" >> /tmp/parameters.tmp
    echo "CBH4=$CBH4" >> /tmp/parameters.tmp
       }

    export -f GTK_Apply
	
    # do not "quote" labels 
    export GTK_CB_CBYNH4='
    <window title="CB -horz CBYNH4"  width-request="220" >
    <hbox>
          <hbox>
                <checkbox active="'$CBH1'">
                <label>CheckH01   </label>
                <variable>CBH1</variable>
                </checkbox>
          </hbox>
          <hbox>
                <checkbox active="'$CBH2'">
                <label>CheckH02   </label>
                <variable>CBH2</variable>
                </checkbox>
          </hbox>
          <hbox>
                <checkbox active="'$CBH3'">
                <label>Check0H3   </label>
                <variable>CBH3</variable>
                </checkbox>
          </hbox>
          <hbox>
                <checkbox active="'$CBH4'">
                <label>CheckH04   </label>
                <variable>CBH4</variable>
                </checkbox>
          </hbox>
          <hbox>
             <button>
                <input file stock="gtk-apply"></input>
                <action>'GTK_Apply'</action>
                <action>exit:ok</action>
             </button>
          </hbox>
    </hbox>
    </window>'

    gtkdialog --program GTK_CB_CBYNH4
    #~ eval "gtkdialog --center -p GTK_CB_CBYNH4"

    echo "program GTK_CB_CBYNH4 has finished"
	cat /tmp/parameters.tmp
    sleep 1

    #
    GTK_ReStart
    #

fi
### end of "CBYNH4" block
########################################################################


######## CB_YN-V-4 #######################################################

### EXIT:CBYNV4 ### Check_Box
echo "---- CBYNV4 ---------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBYNV4+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBYNV4+'</action>
#(:		  if [ "$EXIT" = "CBYNV4+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYNV4" ] ; then

   n=0

    #~ cat parameters . /tmp/parameters.tmp    ### previous var values or touch file

    GTK_Apply(){
    echo "CB1=$CB1" >  /tmp/parameters.tmp
    echo "CB2=$CB2" >> /tmp/parameters.tmp
    echo "CB3=$CB3" >> /tmp/parameters.tmp
    echo "CB4=$CB4" >> /tmp/parameters.tmp
       }
    export -f GTK_Apply

    # do not "quote" labels 
    export GTK_CB_CBYNV4='
    <window title="CB -vert CBYNV4" width-request="220">
    <vbox>
          <vbox>
                <checkbox active="'$CB1'">
                <label>Check01                </label>
                <variable>CB1</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CB2'">
                <label>Check02                </label>
                <variable>CB2</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CB3'">
                <label>Check03                </label>
                <variable>CB3</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CB4'">
                <label>Check04                </label>
                <variable>CB4</variable>
                </checkbox>
          </vbox>
          <hbox>
             <button>
                <input file stock="gtk-apply"></input>
                <action>'GTK_Apply'</action>
                <action>exit:ok</action>
             </button>
          </hbox>
    </vbox>
    </window>'

    gtkdialog --program GTK_CB_CBYNV4
    #~ eval "gtkdialog --center -p GTK_CB_CBYNV4"

    echo "program GTK_CB_CBYN4 has finished"
	#~ cat /tmp/parameters.tmp
    sleep 1
    #
    GTK_ReStart
    #

fi
### end of "CBYNV4" block
########################################################################






######## CB_YN-2 #######################################################

### EXIT:CBYN2 ### Check_Box
echo "---- CBYN2 -----------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBYN2+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBYN2+'</action>
#(:		  if [ "$EXIT" = "CBYN2+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYN2" ] ; then

   n=0

    GTK_Apply(){
    echo "CBY=$CBY" >  /tmp/parameters.tmp
    echo "CBN=$CBN" >> /tmp/parameters.tmp
       }

    export -f GTK_Apply

    # do not "quote" labels 
    export GTK_CB_CBYN2='
    <window title="CB YN 2 horz CBYN2">
    <vbox>
    <hbox>
          <vbox>
                <checkbox active="'$CBY'">
                <label>Yes        </label>
                <variable>CBY</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CBN'">
                <label>No        </label>
                <variable>CBN</variable>
                </checkbox>
          </vbox>
    </hbox>

          <hbox>
             <button>
                <input file stock="gtk-apply"></input>
                <action>'GTK_Apply'</action>
                <action>EXIT:ok</action>
             </button>
          </hbox>

    </vbox>
    </window>'

    gtkdialog --program GTK_CB_CBYN2
    #~ eval "gtkdialog --center -p GTK_CB_CBYN2"

    echo "program GTK_CB_CBYN2 has finished "
	#~ cat /tmp/parameters.tmp
    sleep 1
    #
    GTK_ReStart
    #
fi
### end of "CBYN2" block
########################################################################





### EXIT:CBYN3 ### Check_Box
echo "---- CBYN3 ----------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBYN3+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBYN3+'</action>
#(:		  if [ "$EXIT" = "CBYN3+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYN3" ] ; then

   n=0

    GTK_Apply(){
    echo "CBY=$CBY" > /tmp/parameters.tmp
    echo "CBN=$CBN" >> /tmp/parameters.tmp
    echo "CBX=$CBX" >> /tmp/parameters.tmp
       }
    export -f GTK_Apply

    # do not "quote" labels 
    export GTK_CB_CBYN3='
    <window title="CB YN 3 horz CBYN3">
    <vbox>
    <hbox>
          <vbox>
                <checkbox active="'$CBY'">
                <label>Yes        </label>
                <variable>CBY</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CBN'">
                <label>No        </label>
                <variable>CBN</variable>
                </checkbox>
          </vbox>
          <vbox>
                <checkbox active="'$CBX'">
                <label>Maybe     </label>
                <variable>CBX</variable>
                </checkbox>
          </vbox>
    </hbox>

          <hbox>
             <button>
                <input file stock="gtk-apply"></input>
                <action>'GTK_Apply'</action>
                <action>EXIT:ok</action>
             </button>
          </hbox>
    </vbox>
    </window>'

    gtkdialog --program GTK_CB_CBYN3
    #~ eval "gtkdialog --center -p GTK_CB_CBYN3"

    echo "program GTK_CB_CBYN3 has finished"
	#~ cat /tmp/parameters.tmp
    sleep 1

    #
    GTK_ReStart
    #
fi
### end of "CBYN3" block
########################################################################






###  "CBYN3" Check_Box #######################################################

### EXIT:CBYN3C ###  "CBYN3C" Check_Box
echo "---- CBYN3C -----------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBYN3C+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBYN3C+'</action>
#(:		  if [ "$EXIT" = "CBYN3C+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYN3C" ] ; then

    ### For / Done  LOOPING
    for COLOR in red green blue ;do
    TEXT=YES
    [ $COLOR = red ] && TEXT=NO
    echo '<svg version="1.1" width="50" height="40">
          <rect
            style="fill:'$COLOR';stroke-width:0"
            width="50" height="40"/>
          <text style="fill:black;stroke:none;font-family:DejaVu;font-size:24;fill-opacity:9;text-anchor:end;writing-mode:lr;"
            x="55" y="28">'$TEXT'
          </text>

    </svg>
    '>/tmp/SVG_$COLOR.svg

    done &
    #
	sleep 1
	#
    GTK_ReStart
    #

fi
### end of "CBYN3C" Check_Box
########################################################################







### "CBYN4" Check_Box ################################################################

### EXIT:CBYN4 ### "CBYN4" Check_Box
echo "---- CBYN4 ------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBYN4+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBYN4+'</action>
#(:		  if [ "$EXIT" = "CBYN4+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBYN4" ] ; then

       n=0

        echo "CheckBox_Color YesNo block "

        export GTK_CB_CBYN4='
     <window border-width="20">
     <vbox>
                <text>
                      <label>My 'color' question?</label>
                </text>

        <hseparator></hseparator>

        <hbox homogeneous="true">
                 <button relief="2">
                      <width>50</width>
                      <height>40</height>
                      <input file>/tmp/SVG_green.svg</input>
                      <action>xmessage "Clicked Yes button"</action>
                </button>
                <button  relief="2">
                      <width>50</width>
                      <height>40</height>
                      <input file>/tmp/SVG_red.svg</input>
                      <action>xmessage "Clicked No button"</action>
                </button>
        </hbox>

     </vbox>
     </window>'

        gtkdialog --program GTK_CB_CBYN4

        #~ eval "gtkdialog --center -p GTK_CB_CBYN4"

        echo "Program GTK_CB_YNC4 'Color-X' has finished"
	#~ cat ... 
    #~ exit 0
    GTK_ReStart
    #

fi

### end of "CBYN4" Check_Box
########################################################################





######## CBOK1 ########################################################

### EXIT:CBOK1 ### Check_Box
echo "---- CBOK1 -----------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CBOK1+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CBOK1+'</action>
#(:		  if [ "$EXIT" = "CBOK1+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "CBOK1" ] ; then

   n=0

    ### small box with icon, button 'ok', plus  sleep

    /usr/lib/gtkdialog/box_ok "? CB Fix Lock-File" error " $@"
    sleep 1

    /usr/lib/gtkdialog/box_ok "? ERROR" error "? Something could NOT run. "
    sleep 1

    /usr/lib/gtkdialog/box_ok "? ERROR" error "? savedata FileName not found"
    sleep 1

    GTK_ReStart
    #

fi
### end of "CBOK1" block
########################################################################





#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'+'</action>
#(:		  if [ "$EXIT" = "+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:




########################################################################

### EXIT:EB01 ### Edit_Box
echo "----EB01---------------------------------------------XXX"
if [ "$EXIT" = "EB01" ] ; then

   n=0

    ### uses "Xdialog"
    function GTK_EB01_warn(){
        [ ! -f "$FILE" ] &&  xmessage "Filename needed" && exit 0
    Xdialog --title "Save" --msgbox "Successful saving" 0 0
    echo "$EDITOR" > "$FILE"
    exit 0
    }

    export -f GTK_EB01_warn


    export GTK_EB01='
    <window>
    <vbox>
    <frame Save 'GTK_Edit_Box-1' text to a file>

           <edit>
                <variable>EDITOR</variable>
                <width>350</width><height>150</height>
                <default>"This is the default text of the editor."</default>
           </edit>

            <hseparator></hseparator>
            <hbox>
                   <text><label>Filename</label></text>
                  <entry fs-action="newfile" fs-folder="'$HOME'"
                        fs-filters-mime="text/plain|text/html"
                        fs-title="Select an existing file or type in a new filename">
                  <variable>FILE</variable>
                  </entry>

                  <button  tooltip-text="Select a file for saving">
                  <input file stock="gtk-open"></input>
                  <action type="fileselect">FILE</action>
                  <action>echo "$EDITOR" > $FILE</action>
                  </button>
          </hbox>
           <hbox>
                 <button>
                 <action>GTK_EB01_warn</action>
                 <label>Save to file</label>
                 </button>
           </hbox>
    </frame>
    </vbox>
    </window>'

### Save to File must call GTK_EB01_warn function.

    gtkdialog --program GTK_EB01    ### with defaults.

    #~ eval "gtkdialog --center -p GTK_EB01"

    echo "program GTK_EB01 has finished"

    #
    GTK_ReStart
    #

fi
### end of "EB01" block
########################################################################






#######################################################################
#######################################################################
#######################################################################
#######################################################################

### working ABOUT
### EXIT:ABOUT+ ### About_Box
echo "---- EXIT:ABOUT+ ------------------------------------XXX"

#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'ABOUT+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 	# written with "gtkdialog" 
#(: method: <action>EXIT:'ABOUT+'</action>
#(:			if [ "$EXIT" = "ABOUT+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 	### function GTK_About_Box()  
#(:
if [ "$EXIT" = "ABOUT+" ]  ; then

   n=0

    #(: VERSION=1.0 
	#(: 220301-1700

	#(: GTK_About_Box
	#(: written with "gtkdialog" 


    ##################;;;;;;;;;;;;;;;;
    #
    #  MAIN GUI for GTK_About_Box
    #
    ##################;;;;;;;;;;;;;;;;
    #
    # GUI #1 for "GTK_About" 
    #
    ##################;;;;;;;;;;;;;;;;

	### function GTK_About_Box() {###} ###

	# written with "gtkdialog" 
    export GTK_About="
    <window title=\"ABOUT\"  icon-name=\"mini-clock\" window_position=\"1\">

     <notebook labels=\"GTK|About|License\">

      <frame>
          <text> <label>$(gettext "Recommendation:")   </label></text>
          <text> <label>$(gettext "Item 1," ) </label></text>
          <text> <label>$(gettext "Item 2, ") </label></text>
          <text> <label>$(gettext "Item 3. ") </label></text>
      </frame>

      <frame>
       <text><label>\"\"</label></text>

       <progressbar>
        <input>echo 0; echo \"About progress: $gcVerDts\"</input>
       </progressbar>

        <text use-markup=\"true\"><label>\"<b>Glen Ellis, Copyright GNU</b>\"</label></text>
        <text use-markup=\"true\"><label>\"<b>X</b>\"</label></text>
        <text use-markup=\"true\"><label>\"X\"</label></text>
        <text use-markup=\"true\"><label>\"<b>written 2019-2020</b>\"</label></text>

       <text height-request=\"30\"><label>\"\"</label></text>

      </frame>
      <frame>
       <text use-markup=\"true\"><label>\"B2T is released under the <b>GNU General Public License</b> (GPL). You have the right to use and modify this software in any way you like, so long as any derivative works remain under a GPL license.\"</label></text>
       <text use-markup=\"true\"><label>\"This program is distributed in the hope that it will be useful, but <b><span color='"'red'"'>WITHOUT ANY WARRANTY</span></b>. See the GNU General Public License homepage for more details.\"</label></text>
       <hbox>
        <button>
         <label>\"http://www.gnu.org/licenses/\"</label>
         <action>defaulthtmlviewer http:\/\/www.gnu.org\/licenses\/</action>
        </button>
       </hbox>
      </frame>
     </notebook>

    </window>"

	# written with "gtkdialog" 
    gtkdialog --program=GTK_About


          #~ <text> <label>$(gettext "There are two types of recordings possible,
          #~ (1) Countdown (2) and Timer.
          #~ Use Timer if you know the time of the start of the recording.
          #~ There will be a message of completion when the recording has finished.
          #~ You can set several recording times in one session.
          #~ The default path of your recording  can be set in Preferences.
          #~ Wave and MP3 Stereo are high quality whereas MP3 Mono is lower quality,
          #~ but the file size is small!!  A countdown of zero starts recording immediately.
          #~ A lack of numerals will be signaled. The utility program 'arecord' runs in the background.
          #~ The STOP button will stop a scheduled recording, or a recording that is currently underway.




    ##################;;;;;;;;;;;;;;;;
    #
    # GUI #2 for "GTK_AboutDialog"
    #
    ##################;;;;;;;;;;;;;;;;

	# written with "gtkdialog" 
    export GTK_About_Dialog='
    <window title="'Main_!_About'">
    <vbox width-request="200">
               <text height-request="80"><label>"Main_!_About"</label></text>
    <hseparator></hseparator>
    <hbox>

               <button  space-expand="false" space-fill="false"   tooltip-text="Help">
               <input file stock="gtk-help"></input>
               <action>launch:'GTK_!_About'</action>
               </button>

               <text space-expand="true" space-fill="true">
               <label>"'GTK_About_Dialog' has finished"</label>
               </text>
               <button ok></button>

    </hbox>
    </vbox>
    </window>'

    gtkdialog --program=GTK_About_Dialog    # error in GTK , in terminal, not fatal 
	# same function : 
	# same function : 
    #~ eval "gtkdialog --center -p GTK_About_Dialog" # error in GTK , in terminal, not fatal 

    echo "Program 'GTK_About_Dialog' has finished"
    #
    echo "Return from ABOUT"
    #
    GTK_ReStart
    #

fi		# error in GTK , in terminal, not fatal 
### end of "ABOUT+" block
########################################################################
#######################################################################
#######################################################################
#######################################################################





#######################################################################

### EXIT:HB01 ### Help_Box ###
echo "----HB01---------------------------------------------XXX"
if [ "$EXIT" = "HB01" ] ; then

   n=0
echo ">>> Program 'GTK_Help_Box_Main_Dialog' has finished"



export TEXT=`printf   "Tom\nDick\nHarry\nMary"`
export GTK_Help_Box_Main_Dialog\
='<window title="My project">
<vbox width-request="200">
           <text height-request="80"><label>""</label></text>
<hseparator></hseparator>
<hbox>
           <button  space-expand="false" space-fill="false"   tooltip-text="Help">
           <input file stock="gtk-help"></input>
           <action>Xdialog --title "Help" --ok-label "OK" --backtitle "\n$TEXT \n "  --msgbox  "" 0 0</action>
           </button>
           <text space-expand="true" space-fill="true">
           <label>"    "</label>
           </text>
           <button ok></button>
</hbox>
</vbox>
</window>'

### will run on defaults : not required : gtkdialog --program=GTK_Help_Box_Main_Dialog

eval "gtkdialog --center -p GTK_Help_Box_Main_Dialog"

echo "<<< Program 'GTK_Help_Box_Main_Dialog' has finished"

    #
    GTK_ReStart
    #

fi
### end of "HB01" block
########################################################################








##### Test03 ###################################################################
############# Test03 ###########################################################
##################### Test03 ###################################################

echo "----Test03---------------------------------------------XXX"
if [ "$EXIT" = " Test03 " ] ; then

   n=0
    #
    GTK_ReStart
    #

fi
### end of "Test03" block
########################################################################





########################################################################
########################################################################
########################################################################

### EXIT:'ICON+' ###
echo "----Icon------------------------------------------------XXX"
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(FT_EXIT:'CTB+')
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: <action>EXIT:'CTB+'</action>
#(:			if [ "$EXIT" = "CTB+" ] ; then
#(: sends: 
#(: rationale: 
#(: note : 
#(:
if [ "$EXIT" = "ICON+" ] ; then

n=0
export Icon_Dialog='
<vbox>
  <frame Stock>
    <tree>
      <height>600</height><width>250</width>
      <label>Stock ID</label>
        <item stock="gtk-dialog-authentication">gtk-dialog-authentication</item>
        <item stock="gtk-dialog-info">gtk-dialog-info</item>
        <item stock="gtk-dialog-warning">gtk-dialog-warning</item>
        <item stock="gtk-dialog-error">gtk-dialog-error</item>
        <item stock="gtk-dialog-question">gtk-dialog-question</item>
        <item stock="gtk-dnd">gtk-dnd</item>
        <item stock="gtk-dnd-multiple">gtk-dnd-multiple</item>
        <item stock="gtk-about">gtk-about</item>
        <item stock="gtk-add">gtk-add</item>
        <item stock="gtk-apply">gtk-apply</item>
        <item stock="gtk-bold">gtk-bold</item>
        <item stock="gtk-cancel">gtk-clear</item>
        <item stock="gtk-cdrom">gtk-cdrom</item>
        <item stock="gtk-clear">gtk-clear</item>
        <item stock="gtk-close">gtk-close</item>
        <item stock="gtk-color-picker">gtk-color-picker</item>
        <item stock="gtk-convert">gtk-convert</item>
        <item stock="gtk-connect">gtk-connect</item>
        <item stock="gtk-copy">gtk-copy</item>
        <item stock="gtk-cut">gtk-cut</item>
        <item stock="gtk-delete">gtk-delete</item>
        <item stock="gtk-directory">gtk-directory</item>
        <item stock="gtk-disconnect">gtk-disconnect</item>
        <item stock="gtk-edit">gtk-edit</item>
        <item stock="gtk-execute">gtk-execute</item>
        <item stock="gtk-file">gtk-file</item>
        <item stock="gtk-find">gtk-find</item>
        <item stock="gtk-find-and-replace">gtk-find-and-replace</item>
        <item stock="gtk-floppy">gtk-floppy</item>
        <item stock="gtk-fullscreen">gtk-fullscreen</item>
        <item stock="gtk-goto-bottom">gtk-goto-bottom</item>
        <item stock="gtk-goto-first">gtk-goto-first</item>
        <item stock="gtk-goto-last">gtk-goto-last</item>
        <item stock="gtk-goto-top">gtk-goto-top</item>
        <item stock="gtk-go-back">gtk-go-back</item>
        <item stock="gtk-go-down">gtk-go-down</item>
        <item stock="gtk-go-forward">gtk-go-forward</item>
        <item stock="gtk-go-up">gtk-go-up</item>
        <item stock="gtk-harddisk">gtk-harddisk</item>
        <item stock="gtk-help">gtk-help</item>
        <item stock="gtk-home">gtk-home</item>
        <item stock="gtk-index">gtk-index</item>
        <item stock="gtk-indent">gtk-indent</item>
        <item stock="gtk-info">gtk-info</item>
        <item stock="gtk-unindent">gtk-unindent</item>
        <item stock="gtk-italic">gtk-italic</item>
        <item stock="gtk-jump-to">gtk-jump-to</item>
        <item stock="gtk-justify-center">gtk-justify-center</item>
        <item stock="gtk-justify-fill">gtk-justify-fill</item>
        <item stock="gtk-justify-left">gtk-justify-left</item>
        <item stock="gtk-justify-right">gtk-justify-right</item>
        <item stock="gtk-leave-fullscreen">gtk-leave-fullscreen</item>
        <item stock="gtk-missing-image">gtk-missing-image</item>
        <item stock="gtk-media-forward">gtk-media-forward</item>
        <item stock="gtk-media-next">gtk-media-next</item>
        <item stock="gtk-media-pause">gtk-media-pause</item>
        <item stock="gtk-media-play">gtk-media-play</item>
        <item stock="gtk-media-previous">gtk-media-previous</item>
        <item stock="gtk-media-record">gtk-media-record</item>
        <item stock="gtk-media-rewind">gtk-media-rewind</item>
        <item stock="gtk-media-stop">gtk-media-stop</item>
        <item stock="gtk-network">gtk-network</item>
        <item stock="gtk-new">gtk-new</item>
        <item stock="gtk-no">gtk-no</item>
        <item stock="gtk-ok">gtk-ok</item>
        <item stock="gtk-open">gtk-open</item>
        <item stock="gtk-paste">gtk-paste</item>
        <item stock="gtk-preferences">gtk-preferences</item>
        <item stock="gtk-print">gtk-print</item>
        <item stock="gtk-print-preview">gtk-print-preview</item>
        <item stock="gtk-properties">gtk-properties</item>
        <item stock="gtk-quit">gtk-quit</item>
        <item stock="gtk-redo">gtk-redo</item>
        <item stock="gtk-refresh">gtk-refresh</item>
        <item stock="gtk-remove">gtk-remove</item>
        <item stock="gtk-revert-to-saved">gtk-revert-to-saved</item>
        <item stock="gtk-save">gtk-save</item>
        <item stock="gtk-save-as">gtk-save-as</item>
        <item stock="gtk-select-color">gtk-select-color</item>
        <item stock="gtk-select-font">gtk-select-font</item>
        <item stock="gtk-sort-ascending">gtk-sort-ascending</item>
        <item stock="gtk-sort-descending">gtk-sort-descending</item>
        <item stock="gtk-spell-check">gtk-spell-check</item>
        <item stock="gtk-stop">gtk-stop</item>
        <item stock="gtk-strikethrough">gtk-strikethrough</item>
        <item stock="gtk-undelete">gtk-undelete</item>
        <item stock="gtk-underline">gtk-underline</item>
        <item stock="gtk-undo">gtk-undo</item>
        <item stock="gtk-yes">gtk-yes</item>
        <item stock="gtk-zoom-100">gtk-zoom-100</item>
        <item stock="gtk-zoom-fit">gtk-zoom-fit</item>
        <item stock="gtk-zoom-in">gtk-zoom-in</item>
        <item stock="gtk-zoom-out">gtk-zoom-out</item>
    </tree>
  </frame>
  <hbox>
    <button ok></button>
  </hbox>
</vbox>
'

#~ gtkdialog --program=Icon_Dialog

eval "`gtkdialog --center -p Icon_Dialog`"

             #~ <button label="" has-focus="false">
                #~ <action>n=0</action>
             #~ </button>

		 #~ <button label="GtkDialog" has-focus="false">
			#~ <action>. /usr/share/applications/gtkdialog-tutorial-manual.desktop</action>
 		 #~ </button>
    #
    GTK_ReStart
    #

fi
### end of "Icon+" block
########################################################################










########################################################################
########################################################################
########################################################################
### begin "PlayBell" block
n=0
echo "----PB01-----------------------------------------------XXX"
if [ "$EXIT" = "PB01" ] ; then
    #~ n=0

    ### these are real files
    [  -f rc.z_GTK ]  &&  { file_exists=1; echo 'if file exists --- OK '; } && sleep 1
    ### these are real files
    [! -f rc.z_GTK ]  &&  { file_exists=1; echo 'if not file exists --- NOT OK '; } && sleep 1

    echo "ding"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh  "ding"
    echo "thee"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh  "thee"
    echo "gong"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh  "gong"
    echo "1"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh  "1"
    echo "2"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "2"
    echo "3"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "3"
    echo "4"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "4"
    echo "5"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "5"
    echo "6"
       [ -f "/etc/rc.d./rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "6"
    echo "7"
       [ -f "/etc/rc.d/rc.zaplaybell" ] &&   /etc/rc.d/rc.zaplaybell.sh "7"
    echo "0"


echo "--------------------------------------------------------XXX"

    #
    GTK_ReStart
    #
fi  ### end: "PlayBell" block
########################################################################









########################################################################
########################################################################
########################################################################
echo "----QUIT-------------------------------------------------XXX"
if [ "$EXIT" = "QUIT" ] || [ "$EXIT" = "" ] ; then
    #~ n=0

    ### Otherwise, Trace , cleanup,  exit
    ### and we always cleanup and exit !!!!!!!!!!
    ### Therefore, No Testing is required here.
    ### gae this is a catch-all for any "quit" from above.
    ###
        ### so, in all cases
        ### we will cleanup and then EXIT 0 !!!!!!!  Display in 'Execute Terminal'
    echo "----------------------------------XXX"
    echo "Check-After-Main-GUI Exit  "
    echo "[ "$EXIT" = "QUIT" ] so 'cleanup'"
    echo "----------------------------------XXX"
    #~ sleep 3
    echo "----------------------------------XXX"
    echo "Next is cleanup'"
    echo "----------------------------------XXX"
    ### kill $pidx  ### gae ### if run multiple times in a sequence of code, then error "no such process ###
    GTK_cleanup
    echo "----------------------------------XXX"
    echo "Next is 'exit 0'"
    exit 0  ### EXIT SCRIPT !!!
    echo "----------------------------------XXX"

    ### Do Not RESTART script auto ###
    ### NO !!!   function ???_restart
    ### GTK will handle "ReStart"

fi
### end QUIT
#=======================================================================








########################################################################
### Otherwise, "QUIT" Fall Thru : Trace , cleanup,  exit
### and we always cleanup and exit !!!!!!!!!!
### Therefore, No Testing is required here.
### gae this is a catch-all for any "quit" from above.
###
    ### so, in all cases
    ### we will cleanup and then EXIT 0 !!!!!!!  Display in 'Execute Terminal'
#~ echo "----------------------------------XXX"
#~ echo "Check-After-Main-GUI Exit  "
#~ echo "[ "$EXIT" = "QUIT" ] so 'cleanup'"
#~ sleep 3
#~ echo "Next is 'GTK_cleanup'"
#~ ### kill $pidx  ### gae ### if run multiple times in a sequence of code, then error "no such process ###
#~ GTK_cleanup
#~ echo "Next is 'exit 0'"
#~ exit 0
###
#=======================================================================



### END ###
########################################################################










