#!/bin/bash
#
#(: TXN.sh
#(: TXN-Normal.sh 
#(:    derived from TXN_Pull_All_Code.sh  

# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcSysDevDob="220923-0600"		
# System Developer ID name of this Linux BASH script
export gcSysDevId="TXN"	
# ##^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#(: pulls out lines that 'grep' test.
#(:   grep operates via "inverted" key-symbols: 
#(:   "#(:"   "#:"   "# " 
#(:
#(: === NOTE: operations are dependent on the following method =========
#(:
#(: method of "Programmer Docs"   vs   "common comments".
#(: "TXN" is a Copy-No-Notes script, based on 'grep' and 'BASH' 
#(:       
#(: Key-Symbols are detected as leading symbols beginning each line of code: 
#(:
#(: "#(:" Lines are extracted by "TXN" , 
#(:       Lines are cast into separate 'cast_#(:_.txt File. 
#(:       'Cast' file used for Prog Dox to build Documentation for project . 
#(: 
#(: "#:"  Lines are 'cut' via "TXN"
#(:       Currently deleted. 
#(:       Key-Symbole must be used for 'in-line' comments to be cut. 
#(:
#(: "# "  Lines of BASH script comments remain, intact, in the output file. 
#(:       Placing "# " as an in-line comment will allow 
#(:       common user notes to be retained. 
#(:
#(: "blank Line"  will be culled by "TXN".
#(:
#(: Executable script is "TXN_exe.sh"
#(: Input file is : "TXN_0.txt"
#(: Output files are: 
#(: "TXN_comments.txt" for key-symbol "#(:" 
#(: "TXN_code-1.txt" is partial conversion. 
#(: "TXN_code-2.txt" is partial conversion.  
#(: "TXN_code-3.txt" is partial conversion. 
#(: "TXN_code-4.txt" is final output, stripped of comments. 
#(:      "TXN_code-4.txt" Must have permissions set to "Executable"
#(:


########################################################################
### test header for TXN compactor ######################################
### guide for entering "comments" or "notes" 

#!    #(: "#(:" "#(: "     to build a programmer's documentation. 

#!    "#!" "#! "           for BASH "comment" line:   "#:"  "#: " 
#!     "#" "# "            for common source-code 'comment' line. 

#!     "#:" "#: " cut this line. 
#:     "#:" "#: " cut this line. 

#!    "#!"  "#! "          for permanent BASH "document" line:   
#!    "#!"  "#! "          Maintain this line.is key-symbol.


#!     "#"  "# "  maintain this line. "# " key-symbol.
#     this is a comment line .   "# " key-symbol.

########################################################################



#(: ====================================================================
#(: function "end" must have        }    or    } #
#(: gui end must have gui      </window>'    with 'grave' mark '`' 
#(: "#! " is a permanent marker. tricks grep .
#(:
#(: ====================================================================
#(:
#(: Transfer eXecutable Code
#(: Pull All Code
#(: goal #1 : Copy Only Code 
#(:
#(: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer Initial DOB 
export gcSysDevDob="220923-0600"
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
# PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/root/my-applications/bin/ 
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/MY_/usr-share/My_Dev_/Edit_TXN

# manually write "ID" , will pull via "gcSD_ID" plus "gcSD_BASE" control . 
# requires a "File Select" routine. 

#(: ${gcSD_ID}_0.txt MUST contain the SOURCE 
#(: TXN_exe.sh  runs "local" on ${gcSD_ID} source code ONLY. 
#(: TXN_exe.sh  writes to ${gcSD_ID} location

#(: Source Code is loaded into TXN_0.txt 
gcSD_IDsourcecode="CTB" # ID for Source Code 
gcSD_ID="TXN"   # subdir for development "TXN"    :::   /Edit_subdir , ie, TXN, MGN, CTB, C2M,  ...

# filename Source = local = "TXN-0.txt"
# source is LOCAL to rc.z_TXL_exe.sh

# subdir holding exe.sh
gcSD_BASE="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}"   # subdir holding source-code.
# exe script 
gcSD_Exe="${gcSD_BASE}/${gcSD_ID}_exe.sh"   # exe script 

echo "==========================================================="
echo "ID: ${gcSD_ID}"
echo "Exe: ${gcSD_Exe} "
echo "Build: from imported  [ ${gcSD_IDsourcecode} ]  source-code"
echo "==========================================================="
sleep .3

#: ;;; build Code comments  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
echo "Build  into TXN_comments.txt >>>==="

# FnSrcX="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_TXN       /TXN_0.txt"
lcFnSrc0="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_0.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_comments.txt"

rm -f ${lcFnTrg}
touch ${lcFnTrg}

echo "#!!! ${lcFnTrg}"  >  ${lcFnTrg}
grep "#(:" "${lcFnSrc0}" >> "${lcFnTrg}"   # Keep  'prog note'  "#(:"  lines

chmod +x ${lcFnTrg}
#:

#: ;;; build Code-1 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#: ;;; grep -v #(:     to "${lcFnTrg}_code-1" 
echo "Build  'code-1.txt' ==="

lcFnSrc="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_0.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_code-1.txt"
rm -f ${lcFnTrg}
touch ${lcFnTrg}

echo "### ${lcFnTrg}"  > "${lcFnTrg}"  
grep -v "#(:" "${lcFnSrc}" >> "${lcFnTrg}"  

chmod +x ${lcFnTrg}

#: ;;; build Code-2 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
echo "Build  'code-2.txt' ==="

lcFnSrc="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_code-1.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_code-2.txt"
rm -f ${lcFnTrg}
touch ${lcFnTrg}

echo "### ${lcFnTrg}"  > "${lcFnTrg}"  
grep -v "#:" $lcFnSrc >> "${lcFnTrg}"        

chmod +x ${lcFnTrg}

#: ;;; copy Non-Blank-Lines to "${lcFnTrg}_3"
#: ;;; build Code 3 ;;; BEST ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ echo "Build  'code-3.txt' ==="
echo "#<<< START  ### (3)  grep . A B    _BEST_======="

lcFnSrc="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_code-2.txt"
lcFnTrg="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_code-3.txt"
rm -f ${lcFnTrg}
touch ${lcFnTrg}

echo "### ${lcFnTrg}"  > "${lcFnTrg}"  
grep . ${lcFnSrc} >> ${lcFnTrg}        # "." transfers SrcFile if LineLen > 0 

chmod +x ${lcFnTrg}

echo "#<<< DONE   ### (3)  grep . A B    _BEST_======="

#: ;;; build Code 4 ;;; LEFT-TRIM ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ echo "Build  'code-4.txt' ==="
echo "#>>> START (4)  ### IFS read line , ltrim, echo >>> _code-4.txt ======="

lcFnSrc="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_code-3.txt"
lcFnTrg="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_ID}/${gcSD_ID}_code-4.txt"
rm -f ${lcFnTrg}
touch ${lcFnTrg}

#~ echo "### ${lcFnTrg}"  > "${lcFnTrg}"  

#~ grep -v . ${lcFnSrc3} >> ${lcFnTrg4}   # "." transfers SrcFile if LineLen > 0 
#~ chmod +x ${lcFnTrg4}

    # OK, No Blank Lines Copied.
    # note: existing "#" line is copied. 

    # echo "### must be left-trim prior to grep , to trap '#:' "

    # NOTE: use of "      # code   "  might be for 'formatting' purposes.
    #     maybe this should NOT be Left-Trimmed ! 

#~ exit 0

#-----------------------------------------------------------------------
sleep .3

while IFS= read -r line; do

    lcvar=""      # clear for calcs

    var="$line"   # transfer to 'var' 
    var="${var#"${var%%[![:space:]]*}"}"

    lcvar="$var"

    echo "${lcvar}" >> ${lcFnTrg}

done <"${lcFnSrc}"
#-----------------------------------------------------------------------

chmod +x ${lcFnTrg}

echo "" >> ${lcFnTrg}

echo "#<<< DONE  (4)  ### IFS read line , ltrim, echo <<< _code-4.txt ======="
echo "---------------------------------------------------------------"

exit 0

########################################################################
### END of TXN active source-code ######################################
########################################################################



#~ # note:
    #~ # remove trailing whitespace characters
    #~ # var="${var%"${var##*[![:space:]]}"}"
    #~ # echo "3$var" 

    #~ var="$[echo $var | xargs echo -n]"


#~ Note that tr -d "[:space:]" 
    #~ removes both horizontal and vertical whitespace characters (=newlines). 
    #~ To remove just horizontal whitespace characters simply use tr -d " ".















echo "end ======="
exit 0



### END ### END ### END ############################################################
### END ### END ### END ############################################################
### END ### END ### END ############################################################


hint to cut leading   /t and -s   #  TAB  and  SPACE . 
[[:space:]]
 
# Stack Overflow 
echo "Line is EMPTY"
while IFS= read -r line; do
  if [ -z "$line" ]; then
    echo "empty line"
  fi
done <"${lcFnSrc2C}"

echo "read line is empty ========"
read

# If you want to tell whether a line is blank:
echo "Line is BLANK"
while IFS= read -r line; do
  case "$line" in
    '') echo "empty line";;
    *[![:space:]]*) echo "non-blank line";;
    *) echo "non-empty blank line";;
  esac
done <"${lcFnSrc2C}"

echo "read line is blank ========"
read

# You can use Bash regular expression matching if you prefer:

echo "Bash regular expression matching"
while IFS= read -r line; do
  if [[ "$line" =~ ^$ ]]; then
     echo "empty line"
  elif [[ "$line" =~ ^[[:space:]]+$ ]]; then
    echo "non-empty blank line"
  else
    echo "non-blank line"
  fi
done <"${lcFnSrc2C}"

echo "read regular expression ========"
read

# These can be done with pattern matching too (using shell wildcards, which have a different syntax from common regular expressions):

echo "pattern matching using shell wildcards"

while IFS= read -r line; do
  if [[ "$line" == "" ]]; then
     echo "empty line"
  elif [[ "$line" != *[![:space:]]* ]]; then
    echo "non-empty blank line"
  else
    echo "non-blank line"
  fi
done <"${lcFnSrc2C}"

echo "read shell wildcards ========"
read

# "If you merely want to look for empty lines in the file and aren't processing the lines in any other way, you can use grep:"
echo "look for empty lines SIMPLE"

if grep -qxF '' <"${lcFnSrc2C}"; then
  echo "contains an empty line"
fi
echo "read simple empty lines ========"
read

# If you're looking for blank lines that are not empty:
echo "Look for Blank Lines that are NOT EMPTY"

if grep -Ex '[[:space:]]+' <"${lcFnSrc2C}"; then
  echo " contains a non-empty blank line"
fi

# ? simple cull for "empty" line ? grep ? 
echo "read blank lines that are not empty========"
read

# ? Leading White Spaces 
Use sed 's/^ *//g', to remove the leading white spaces. 
There is another way to remove whitespaces using `sed` command. 
The following commands removed the spaces from the variable, $Var 
by using `sed` command and [[:space:]].

# xargs removes leading spaces, compreses multiple spaces. 
echo "   lol  " | xargs

###########################################################################################
###########################################################################################
###########################################################################################

###########################################################################################
# Stack Overflow 
# https://stackoverflow.com/questions/369758/how-to-trim-whitespace-from-a-bash-variable

# There is a solution which only uses Bash built-ins called wildcards:

var="    abc    "
# remove leading whitespace characters
var="${var#"${var%%[![:space:]]*}"}"
# remove trailing whitespace characters
var="${var%"${var##*[![:space:]]}"}"   
printf '%s' "===$var==="

# Here is the same wrapped in a function:

trim() {
    local var="$*"
    # remove leading whitespace characters
    var="${var#"${var%%[![:space:]]*}"}"
    # remove trailing whitespace characters
    var="${var%"${var##*[![:space:]]}"}"
    printf '%s' "$var"
}

# You pass the string to be trimmed in quoted form, e.g.:

trim "   abc   "

# A nice thing about this solution is that it will work with any POSIX-compliant shell.

while IFS= read -r line; do

    local var="$line"
    # remove leading whitespace characters
    var="${var#"${var%%[![:space:]]*}"}"
    # remove trailing whitespace characters
    var="${var%"${var##*[![:space:]]}"}"
    printf '%s' "$var"

done <"${lcFnSrc}"




###########################################################################################

exit 0
###############################################################
