#!/bin/bash
#
#(: TXN-1234.sh 
#(: derived from CNN_Pull_All_Code.sh  
#:
#(: pulls out lines that test via "inverted" keyword "#(:" 
#(: skips lines of "header" framework
#(:
#(: === MGN ============================================================
#(: method of "Programmer Docs"   vs   "common comments".
#(: "CNN" is a Copy-No-Notes script, based on 'grep' 
#(:       
#(: "#(:" Docs are retined by "CNN" , cast into separate DoxFile. 
#(:       used for Prog Dox to build Documentation for project . 
#(:       CNN will pull these out to a separate file for project. 
#(: 
#(: "#:"  Comments are retained  via "CNN"
#(:       used for important Linux info. 	
#(:       must be used for 'in-line' comments. 
#(:
#(: "#"  Comments are culled via "CNN"
#(:       used for non-important, common comments 
#(:       CNN will kill these common comments for min prog/script size.
#(:       Placing "#" as an in-line comment will allow "CNN" to kill the line. 
#(:
#(: function end must have        }    or    } #
#(: gui end must have gui      </window>'    with 'grave' mark '`' 
#(: "#! " is a permanent marker. tricks grep .
#(:
#(: ====================================================================
#(:
#(: Transfer eXecutable Code
#(: Pull All Code
#(: goal #1 : Copy Only Code 
#(:
#(: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer Initial DOB 
export gcSD_Dob="220802-1807"		
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/root/my-applications/bin/ 
# manually write "ID" , will pull via "gcSD_ID" plus "gcSD_BASE" control . 
# requires a "File Select" routine. 

#(: TXN_0.txt MUST contain the SOURCE 
#(: TXN runs on "local" source code ONLY. 

gcSD_IDbase="TXN"   #: /Edit_subdir , ie, MGN, CTB, C2M ...

gcSD_ID="TXN"   #: executable.sh

# filename Source = local = "TXN-0.txt"
gcSD_BASE="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${gcSD_IDbase}"
lcFnExe="${gcSD_BASE}/${gcSD_ID}_exe.sh"
echo "running ${lcFnExe}" 

#: must be manual prior to first run :  chmod -ax ${lcFnExe}
#: ;;; Code #1 run ;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcFnSrc="${gcSD_BASE}/${gcSD_ID}_0.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_1.txt"
touch ${lcFnTrg}
grep -v "#(:" "${lcFnSrc}" > "${lcFnTrg}"   # kill  'note'  lines
#:
#: ;;; Code #2 run ;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcFnSrc="${gcSD_BASE}/${gcSD_ID}_1.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_2.txt"
touch ${lcFnTrg}
grep -v "#~" $lcFnSrc > "${lcFnTrg}"        #: kill  #~  lines
#:
#: ;;; Code #3 run ;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcFnSrc="${gcSD_BASE}/${gcSD_ID}_2.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_3.txt"
touch ${lcFnTrg}
grep -v "# " $lcFnSrc > "${lcFnTrg}"        #: kill all remainder of  #  lines
#:

#~ echo "#! ${gcSD_ID}" > ${lcFnTrg}
#~ lcFnSrc="${gcSD_BASE}/${gcSD_ID}_3.txt"
#~ lcFnTrg="${gcSD_BASE}/${gcSD_ID}_4.txt"
#~ grep ".." $lcFnSrc > "${lcFnTrg}"           #: kill empty lines , ? not required.
#
# ? to do: cut line for first char ;  test for leading [ ! "#" ]  
#
# build final file: shebang, title 
# shebang is already protected via "#!"
# echo "#!/bin/bash" > ${lcFnTrg}


#(: While outer loop  
#(: with Do inner multitesting loop.  

lcFnSrc="${gcSD_BASE}/${gcSD_ID}_3.txt"
lcFnTrg="${gcSD_BASE}/${gcSD_ID}_4.txt"
rm -f ${lcFnTrg}
touch ${lcFnTrg}

#~ exit

while  IFS= read  -r line;  
    n=0
    do
        n=0
       if [ -z "$line" ] ; then
          n=0
       else
        n=0
          echo "${line}" >> ${lcFnTrg} 
        exit 0
       fi
    done

exit 0

while  IFS= read  -r line;  
do 
    n=0
    # sample code: from sfs_load
    # purpose: keep "#(:" and "#:"

    # B2T 'cut' blank field from comment line
    # line="`echo $lcPupSave | cut -f 1 -d "#"`" 

    #: ? to do: cut line for first char ;  test for leading  "#" common comment marker.   

    #: test for leading " " spaces, and leading "#" "# " 
    #
    #: "Keeper" lines must be properly marked "#: " 
    #: "NoKeep" lines must be properly marked "#" 

	case "$line" in
        #: empty line is skipped : priority test !!!
        "") ;;

        #~ " ") ;;     #: leading space is to be maintained.  Might be a lead-in to code or keeper comment . 
        #~ "  ") ;;
        #~ "   ") ;;
        #~ "    ") ;;
        #~ "     ") ;;
        #~ "      ") ;;
        #~ "       ") ;;
        #~ "        ") ;;
        #~ "         ") ;;
        #~ "          ") ;;
        #~ "           ") ;;
        #~ "            ") ;;

        #~ "#:") ;;          #: any leading "#: " "keeper comment" is to be maintained. 
        #~ " #:") ;;
        #~ "  #:") ;;
        #~ "   #:") ;;
        #~ "    #:") ;;
        #~ "     #:") ;;
        #~ "      #:") ;;
        #~ "       #:") ;; 
        
        #~ "#") ;;            #: leading "# "   "comment blank"  "common comment" is trapped. 
        #~ "##") ;;            #: leading "##"   "comment blank"  "common comment" is trapped. 
        #~ "###") ;;            #: leading "###"   "comment blank"  "common comment" is trapped. 

        # "#" plus " " plus "anything" becomes a "common comment" to be trapped.  
        # trapping other "#" variations becomes a fishing game. 
        #
        # if "trapped" then "Not Echo" to FnTrg
        #
        *)         echo "${line}" >> ${lcFnTrg}  ;; 
        #
        # "Keepers" must be properly marked "#: " with the trailing ": "
        # "NoKeepers" must        be marked "# "  simply with a trailing " " 
        #####################################################################################3


    esac


done < ${lcFnSrc}
#:  Need Do While not EOF, load each line,
#:       Do While not EOL , parse for keywords. 
exit 
#########################################################################
#########################################################################
#########################################################################

# Loop method outline 
#~ while IFS= -r read line; 
    #~ for i in $@ ; do
        #~ if [ "$i" = "stop" ] ; then #simple thing to do, do it as fast as possible
            #~ [ "`whoami`" != "root" ] && exec sudo -A ${0} ${@}
            #~ . /etc/rc.d/BOOTCONFIG
            #~ echo "PREVEXTRASFSLIST='$EXTRASFSLIST'"
            #~ echo "PREVEXTRASFSLIST='$EXTRASFSLIST'" > /etc/rc.d/BOOTCONFIG.save
            #~ exit
        #~ fi
    #~ rof
#~ done

	#~ while [ "$1" != "" ]; do ; process ; done

	#~ case $EXIT in Yes|yes|OK|Ok|ok) return 0 ;; esac

# Linux Bash Hints 
#~ Basic Syntax of while read line
#~ The following syntax is used for bash shell to read a file using while loop:

#~ echo "Begin While loop" > /test.txt
#~ while read -r line; 
#~ do 
   #~ echo "$line" ;
   #~ echo "$line" >> /test.txt
#~ done < input.file
#The option ‘-r’ avoids the backslash escapes from being interpreted. 


#~ while read line; 
#~ do 
	#~ echo "$line" > /dev/console ; 
#~ done < OS.txt

#~ cat /etc/passwd | while read LREAD
#~ do
    #~ echo ${LREAD}
#~ done



#~ #!/bin/bash
#~ filename='OS.txt'
#~ n=1
#~ cat /etc/passwd | while read LREAD
#~ do
    #~ echo ${LREAD}
#~ done
#~ while read line; 
#~ do
	#~ # for read each line
	#~ echo "OS distribution line no. $n : $line"
	#~ n=$((n+1))
#~ done < $filename



#~ cat /etc/passwd | while read LREAD
#~ do
   #~ if [ -z "$line" ] 
      #~ n=0
   #~ else
   #~ echo ${LREAD} > ${lcFnTrg}
    #~ fi
#~ done


    #~ "-z line" test : 
	#~ if [ -z "$line" ] || [ "" = "$line" ] || [ " " = "$line" ] || [ " #" = "$line" ]  || [ "	" = "$line" ] ; then
        #~ n=0
        #line=$""
        #echo "z" >> ${lcFnTrg}
    #~ elif [ -z "$line" ] || [ " " = "$line" ] || [ "  " = "$line" ]  || [ "   " = "$line" ] || [ "    " = "$line" ] || [ "     " = "$line" ] ; then
        #~ n=0
        #echo "z" >> ${lcFnTrg}
        #line=$""
    #~ else
        #~ echo "${line}" >> ${lcFnTrg}
    #~ fi


        #~ [ -z "$line" ] ) ;; 
        #~ [ "''" = "$line" ] ) ;;
        #~ [ "' '" = "$line" ] ) ;;
        #~ [ "'  '" = "$line" ] ) ;;
        #~ [ "'   '" = "$line" ] ) ;;
        #~ [ "'    '" = "$line" ] ) ;;
        #~ [ "'     '" = "$line" ] ) ;;
        #~ *)         echo "${line}" >> ${lcFnTrg}  ;; 


#~ exit 0
########################################################################

